package array;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目： 6. Z 字形变换 (convert)
 * 描述：将一个给定字符串 s 根据给定的行数 numRows ，以从上往下、从左到右进行 Z 字形排列。
 *
 * 比如输入字符串为 "PAYPALISHIRING" 行数为 3 时，排列如下：
 *
 * P   A   H   N
 * A P L S I I G
 * Y   I   R
 * 之后，你的输出需要从左往右逐行读取，产生出一个新的字符串，比如："PAHNAPLSIIGYIR"。
 *
 * 请你实现这个将字符串进行指定行数变换的函数：
 *
 * string convert(string s, int numRows);
 *
 * 示例 1：
 输入：s = "PAYPALISHIRING", numRows = 3
 输出："PAHNAPLSIIGYIR"

 * 链接：https://leetcode.cn/problems/zigzag-conversion/
 */
public class Convert {
    public String convert1(String s, int numRows) {
        if(numRows==1)return s;
        List<List<Character>>lists=new ArrayList<>();
        StringBuilder stringBuilder=new StringBuilder();
        for (int i = 0; i < numRows; i++) {
            lists.add(new ArrayList<>());
        }
        int level=0,pos=1;
        for (int i = 0; i < s.length(); i++) {
            if(level==numRows-1)
                pos=-1;
            else if(level==0)
                pos=1;
            lists.get(level).add(s.charAt(i));
            level+=pos;
        }
        for (List<Character> list : lists) {
            for (Character character : list) {
                stringBuilder.append(character);
            }
        }
        return stringBuilder.toString();
    }
    public String convert(String s, int numRows) {
        if(numRows < 2) return s;
        List<StringBuilder> rows = new ArrayList<StringBuilder>();
        for(int i = 0; i < numRows; i++) rows.add(new StringBuilder());
        int i = 0, flag = -1;
        for(char c : s.toCharArray()) {
            rows.get(i).append(c);
            if(i == 0 || i == numRows -1) flag = - flag;
            i += flag;
        }
        StringBuilder res = new StringBuilder();
        for(StringBuilder row : rows) res.append(row);
        return res.toString();
    }
}
