package array;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * 题目：56. 合并区间 (merge)
 * 描述：以数组 intervals 表示若干个区间的集合，其中单个区间为 intervals[i] = [starti, endi] 。请你合并所有重叠的区间，并返回 一个不重叠的区间数组，该数组需恰好覆盖输入中的所有区间 。
 *
 * 链接：https://leetcode.cn/problems/merge-intervals/description/
 *
 示例 1：
 输入：intervals = [[1,3],[2,6],[8,10],[15,18]]
 输出：[[1,6],[8,10],[15,18]]
 解释：区间 [1,3] 和 [2,6] 重叠, 将它们合并为 [1,6].

 示例 2：
 输入：intervals = [[1,4],[4,5]]
 输出：[[1,5]]
 解释：区间 [1,4] 和 [4,5] 可被视为重叠区间。
 */

public class Merge {
    public int[][] merge(int[][] intervals) {
        Arrays.sort(intervals,(a,b)->{
            if(a[0]!=b[0]){
                return a[0]-b[0];
            }else
                return a[1]-b[1];
        });
        List<int[]>merged=new ArrayList<>();
        int[] current = new int[2];
        current[0] = intervals[0][0];
        current[1] = intervals[0][1];
        for (int i = 1; i < intervals.length; i++) {
            if (current[1] >= intervals[i][0]) {
                // 重叠时合并区间，更新右边界
                current[1] = Math.max(current[1], intervals[i][1]);
            }
            else{
                merged.add(new int[]{current[0], current[1]});
                current = new int[]{intervals[i][0], intervals[i][1]};
            }
        }
        merged.add(new int[]{current[0], current[1]});
        return merged.toArray(new int[merged.size()][]);
    }
}
