package backtrack;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * 题目： 40. 组合总和 II (combinationSum2)
 * 描述：给定一个候选人编号的集合 candidates 和一个目标数 target ，找出 candidates 中所有可以使数字和为 target 的组合。
 * candidates 中的每个数字在每个组合中只能使用 一次 。
 * 注意：解集不能包含重复的组合。

 示例 1：
 输入: candidates = [10,1,2,7,6,1,5], target = 8,
 输出:
 [[1,1,6],
 [1,2,5],
 [1,7],
 [2,6]]

 示例 2：
 输入: candidates = [2,5,2,1,2], target = 5,
 输出:
 [[1,2,2],
 [5]]

 * 链接：https://leetcode.cn/problems/combination-sum-ii/
 */
public class CombinationSum2 {
    void backtrack(List<List<Integer>>res,List<Integer>path,int[] candidates,int[]visited,int start,int cur,int target){
        if(cur==target) {
            res.add(new ArrayList<>(path));
            return;
        }
        for (int i = start; i < candidates.length; i++) {
            if(i>0 &&candidates[i]==candidates[i-1]&&visited[i-1]==0)
                continue;
            if(visited[i]==0) {
                cur += candidates[i];
                if(cur>target)
                    return;
                path.add(candidates[i]);
                visited[i] = 1;
                backtrack(res, path, candidates, visited, i + 1, cur, target);
                path.remove(path.size() - 1);
                visited[i] = 0;
                cur -= candidates[i];
            }
        }
    }
    public List<List<Integer>> combinationSum2(int[] candidates, int target) {
        List<List<Integer>>res=new ArrayList<>();
        List<Integer>path=new ArrayList<>();
        int[] visited=new int[candidates.length];
        Arrays.sort(candidates);
        backtrack(res,path,candidates,visited,0,0,target);
        return res;
    }
}
