package backtrack;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目： 77. 组合 (combine)
 * 描述：给定两个整数 n 和 k，返回范围 [1, n] 中所有可能的 k 个数的组合。
 * 你可以按 任何顺序 返回答案。

 示例 1：
 输入：n = 4, k = 2
 输出：
 [[2,4],
 [3,4],
 [2,3],
 [1,2],
 [1,3],
 [1,4],]

 * 链接：https://leetcode.cn/problems/combinations/
 */
public class Combine {
    void backtrack(List<List<Integer>> res,List<Integer>path,int n,int start,int cur,int k){
        if(cur==k){
            res.add(new ArrayList<>(path));
            return;
        }
        for (int i = start; i <= n; i++) {
            path.add(i);
            cur++;
            backtrack(res,path,n,i+1,cur,k);
            cur--;
            path.remove(path.size()-1);
        }
    }
    public List<List<Integer>> combine(int n, int k) {
        List<List<Integer>> res=new ArrayList<>();
        List<Integer>path=new ArrayList<>();
        backtrack(res,path,n,1,0,k);
        return res;
    }
}
