package backtrack;

/**
 * 题目： 79. 单词搜索  (Exist)
 * 描述：给定一个 m x n 二维字符网格 board 和一个字符串单词 word 。如果 word 存在于网格中，返回 true ；否则，返回 false 。
 * 单词必须按照字母顺序，通过相邻的单元格内的字母构成，其中“相邻”单元格是那些水平相邻或垂直相邻的单元格。同一个单元格内的字母不允许被重复使用。

 示例 1：
 输入：board = [["A","B","C","E"],["S","F","C","S"],["A","D","E","E"]], word = "ABCCED"
 输出：true

 示例 2：
 输入：board = [["A","B","C","E"],["S","F","C","S"],["A","D","E","E"]], word = "SEE"
 输出：true

 * 链接：https://leetcode.cn/problems/word-search/
 */
public class Exist {
    boolean flag = false;

    void dfs(char[][] board, String word, int i, int j, int index) {
        if (index == word.length()) {
            flag = true;
            return;
        }
        int r = board.length, c = board[0].length;
        // 检查边界和是否匹配字符
        if (i < 0 || i >= r || j < 0 || j >= c || board[i][j] != word.charAt(index)) {
            return;
        }
        // 记录当前字符并标记为已访问（这里用 '#' 标记已访问，可以用其他不可能出现在 board 中的字符）
        char temp = board[i][j];
        board[i][j] = '#';

        // 向四个方向递归
        dfs(board, word, i - 1, j, index + 1);
        dfs(board, word, i + 1, j, index + 1);
        dfs(board, word, i, j - 1, index + 1);
        dfs(board, word, i, j + 1, index + 1);

        // 回溯还原
        board[i][j] = temp;
    }

    public boolean exist(char[][] board, String word) {
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[0].length; j++) {
                if (board[i][j] == word.charAt(0)) {
                    dfs(board, word, i, j, 0);
                    if (flag) return true;
                }
            }
        }
        return flag;
    }
}
