package backtrack;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目： 22. 括号生成  (generateParenthesis)
 * 描述：数字 n 代表生成括号的对数，请你设计一个函数，用于能够生成所有可能的并且 有效的 括号组合。

 示例 1：
 输入：n = 3
 输出：["((()))","(()())","(())()","()(())","()()()"]

 示例 2：
 输入：n = 1
 输出：["()"]

 * 链接：https://leetcode.cn/problems/generate-parentheses/
 */
//做出来了，但我的写法很丑，改为标准答案
public class GenerateParenthesis {
    // 回溯函数
    void dfs(List<String> res, StringBuilder path, int left, int right, int n) {
        // 如果左右括号都用完了，加入结果
        if (left == n && right == n) {
            res.add(path.toString());
            return;
        }

        // 尝试加左括号
        if (left < n) {
            path.append('(');
            dfs(res, path, left + 1, right, n);
            path.deleteCharAt(path.length() - 1); // 回溯
        }

        // 尝试加右括号（右括号不能多于左括号）
        if (right < left) {
            path.append(')');
            dfs(res, path, left, right + 1, n);
            path.deleteCharAt(path.length() - 1); // 回溯
        }
    }

    public List<String> generateParenthesis(int n) {
        List<String> res = new ArrayList<>();
        dfs(res, new StringBuilder(), 0, 0, n);
        return res;
    }
}
