package backtrack;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目： 17. 电话号码的字母组合  (letterCombinations)
 * 描述：给定一个仅包含数字 2-9 的字符串，返回所有它能表示的字母组合。答案可以按 任意顺序 返回。
 * 给出数字到字母的映射如下（与电话按键相同）。注意 1 不对应任何字母。
 *
 示例 1：
 输入：digits = "23"
 输出：["ad","ae","af","bd","be","bf","cd","ce","cf"]

 示例 2：
 输入：digits = ""
 输出：[]

 * 链接：https://leetcode.cn/problems/letter-combinations-of-a-phone-number/
 */
//重做一遍
public class LetterCombinations {
    public List<String> letterCombinations(String digits) {
        List<String> res = new ArrayList<>();
        // 如果输入为空，直接返回空结果
        if (digits == null || digits.length() == 0) {
            return res;
        }
        // 电话号码对应的字母映射，索引 0 对应数字 2，依此类推
        String[] mapping = {"abc", "def", "ghi", "jkl", "mno", "pqrs", "tuv", "wxyz"};
        // 从索引 0 开始回溯
        backtrack(digits, mapping, 0, new StringBuilder(), res);
        return res;
    }

    private void backtrack(String digits, String[] mapping, int index, StringBuilder combination, List<String> res) {
        // 当组合长度等于输入数字长度时，说明构造出一个完整组合
        if (index == digits.length()) {
            res.add(combination.toString());
            return;
        }
        // 当前数字
        char digitChar = digits.charAt(index);
        // 计算 mapping 数组中的索引，数字 '2' 对应索引 0
        int mappingIndex = digitChar - '2';
        String letters = mapping[mappingIndex];
        // 遍历当前数字对应的每个字母
        for (int i = 0; i < letters.length(); i++) {
            // 选择当前字母，加入组合
            combination.append(letters.charAt(i));
            // 递归构造下一个数字的字母组合
            backtrack(digits, mapping, index + 1, combination, res);
            // 回溯：移除最后加入的字母，尝试其他可能性
            combination.deleteCharAt(combination.length() - 1);
        }
    }
}
