package backtrack;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目： 131. 分割回文串  (partition)
 * 描述：给你一个字符串 s，请你将 s 分割成一些 子串，使每个子串都是 回文串 。返回 s 所有可能的分割方案。

 示例 1：
 输入：s = "aab"
 输出：[["a","a","b"],["aa","b"]]

 示例 2：
 输入：s = "a"
 输出：[["a"]]

 * 链接：https://leetcode.cn/problems/palindrome-partitioning/
 */
//不会
public class Partition {
    /**
     * 递归与回溯：
     * 从字符串的起始位置开始，遍历所有可能的分割点，对于每个可能的子串，先判断它是否为回文串。
     *
     * 如果是回文串，则将其加入当前的分割方案，然后递归处理剩下的部分。
     * 当走到字符串末尾时，说明当前方案已经完成，将该方案加入最终结果。
     * 回溯时需要将上一步加入的子串移除，以便尝试其他分割方案。
     */
    public List<List<String>> partition(String s) {
        List<List<String>> result = new ArrayList<>();
        backtrack(s, 0, new ArrayList<>(), result);
        return result;
    }

    private void backtrack(String s, int start, List<String> current, List<List<String>> result) {
        if (start == s.length()) {
            result.add(new ArrayList<>(current));
            return;
        }
        for (int i = start; i < s.length(); i++) {
            // 提取子串并判断是否为回文
            String sub = s.substring(start, i + 1);
            if (isPalindrome(sub)) {
                current.add(sub);
                backtrack(s, i + 1, current, result);
                current.remove(current.size() - 1);
            }
        }
    }

    // 修改后的回文判断方法，只接收一个字符串
    private boolean isPalindrome(String s) {
        for (int i = 0; i < s.length() / 2; i++) {
            if (s.charAt(i) != s.charAt(s.length() - i - 1)) {
                return false;
            }
        }
        return true;
    }
}
