package backtrack;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * 题目： 47. 全排列 II  (permuteUnique)
 * 描述：给定一个可包含重复数字的序列 nums ，按任意顺序 返回所有不重复的全排列。

 示例 1：
 输入：nums = [1,1,2]
 输出：
 [[1,1,2],
 [1,2,1],
 [2,1,1]]

 示例 2：
 输入：nums = [1,2,3]
 输出：[[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]]

 * 链接：https://leetcode.cn/problems/permutations-ii/
 */

public class PermuteUnique {
    void backtrack(List<List<Integer>>res,List<Integer>path,int[]nums,int[] visited){
        if(path.size()==nums.length){
            res.add(new ArrayList<>(path));
            return;
        }
        for (int i = 0; i < nums.length; i++) {
            if(i > 0 && nums[i] == nums[i - 1] && visited[i - 1] == 0)
                continue;
            if(visited[i]==0){
                visited[i]=1;
                path.add(nums[i]);
                backtrack(res,path,nums,visited);
                path.remove(path.size()-1);
                visited[i]=0;
            }
        }
    }
    public List<List<Integer>> permuteUnique(int[] nums) {
        List<List<Integer>>res=new ArrayList<>();
        List<Integer>path=new ArrayList<>();
        int[] visited=new int[nums.length];
        Arrays.sort(nums);
        backtrack(res,path,nums,visited);
        return res;
    }
}
