package backtrack;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目： 78. 子集  (subsets)
 * 描述：给你一个整数数组 nums ，数组中的元素 互不相同 。返回该数组所有可能的子集（幂集）。
 * 解集 不能 包含重复的子集。你可以按 任意顺序 返回解集。
 *
 示例 1：
 输入：nums = [1,2,3]
 输出：[[],[1],[2],[1,2],[3],[1,3],[2,3],[1,2,3]]

 示例 2：
 输入：nums = [0]
 输出：[[],[0]]

 * 链接：https://leetcode.cn/problems/subsets/
 */
public class Subsets {
    public List<List<Integer>> subsets(int[] nums) {
        List<List<Integer>> res = new ArrayList<>();
        List<Integer> path = new ArrayList<>();
        // 从索引0开始递归
        backtrack(nums, 0, path, res);
        return res;
    }

    private void backtrack(int[] nums, int start, List<Integer> path, List<List<Integer>> res) {
        // 每个递归节点的当前path都构成了一个子集，将其复制加入结果集合中
        res.add(new ArrayList<>(path));
        // 从start开始遍历所有可能的元素
        for (int i = start; i < nums.length; i++) {
            // 做选择：将当前数字加入path
            path.add(nums[i]);
            // 递归：从下一个位置继续选取，避免重复选择
            backtrack(nums, i + 1, path, res);
            // 回溯：撤销选择，继续尝试下一个数字
            path.remove(path.size() - 1);
        }
    }
}
