package binary_search;
/**
 * 题目： 4. 寻找两个正序数组的中位数  (findMedianSortedArrays)
 * 描述：给定两个大小分别为 m 和 n 的正序（从小到大）数组 nums1 和 nums2。请你找出并返回这两个正序数组的 中位数 。
 *
 * 算法的时间复杂度应该为 O(log (m+n)) 。
 *
 示例 1：
 输入：nums1 = [1,3], nums2 = [2]
 输出：2.00000
 解释：合并数组 = [1,2,3] ，中位数 2
 *
 * 链接：https://leetcode.cn/problems/median-of-two-sorted-arrays/

 */
//不会
public class FindMedianSortedArrays {
    public double findMedianSortedArrays(int[] nums1, int[] nums2) {
        int m = nums1.length, n = nums2.length;
        int total = m + n;
        if (total % 2 == 1) {
            // 奇数长度，直接取第 (total+1)/2 小
            return getKth(nums1, 0, nums2, 0, (total + 1) / 2);
        } else {
            // 偶数长度，取第 total/2 和 total/2+1 两个数的平均
            double left = getKth(nums1, 0, nums2, 0, total / 2);
            double right= getKth(nums1, 0, nums2, 0, total / 2 + 1);
            return (left + right) / 2.0;
        }
    }

    // 返回 nums1[start1...] 和 nums2[start2...] 中，第 k 小的数
    private double getKth(int[] nums1, int start1, int[] nums2, int start2, int k) {
        // 如果 nums1 已经“耗尽”，直接从 nums2 里取
        if (start1 >= nums1.length) {
            return nums2[start2 + k - 1];
        }
        // 如果 nums2 耗尽
        if (start2 >= nums2.length) {
            return nums1[start1 + k - 1];
        }
        // 如果 k == 1，取两数组当前头部较小者
        if (k == 1) {
            return Math.min(nums1[start1], nums2[start2]);
        }

        // 各自看 k/2 位置的元素，如果超出边界，则视作 +∞
        int midVal1 = (start1 + k/2 - 1 < nums1.length)
                ? nums1[start1 + k/2 - 1]
                : Integer.MAX_VALUE;
        int midVal2 = (start2 + k/2 - 1 < nums2.length)
                ? nums2[start2 + k/2 - 1]
                : Integer.MAX_VALUE;

        // 抛弃较小者及其前面 k/2 个元素
        if (midVal1 < midVal2) {
            // 抛弃 nums1[start1 ... start1 + k/2 - 1]
            return getKth(nums1, start1 + k/2, nums2, start2, k - k/2);
        } else {
            // 抛弃 nums2[start2 ... start2 + k/2 - 1]
            return getKth(nums1, start1, nums2, start2 + k/2, k - k/2);
        }
    }
}
