package binary_search;

/**
 * 题目： 153. 寻找旋转排序数组中的最小值 (findMin)
 * 描述：已知一个长度为 n 的数组，预先按照升序排列，经由 1 到 n 次 旋转 后，得到输入数组。例如，原数组 nums = [0,1,2,4,5,6,7] 在变化后可能得到：
 * 若旋转 4 次，则可以得到 [4,5,6,7,0,1,2]
 * 若旋转 7 次，则可以得到 [0,1,2,4,5,6,7]
 * 注意，数组 [a[0], a[1], a[2], ..., a[n-1]] 旋转一次 的结果为数组 [a[n-1], a[0], a[1], a[2], ..., a[n-2]] 。
 * 给你一个元素值 互不相同 的数组 nums ，它原来是一个升序排列的数组，并按上述情形进行了多次旋转。请你找出并返回数组中的 最小元素 。
 * 你必须设计一个时间复杂度为 O(log n) 的算法解决此问题。
 * <p>
 * 示例 1：
 * 输入：nums = [3,4,5,1,2]
 * 输出：1
 * 解释：原数组为 [1,2,3,4,5] ，旋转 3 次得到输入数组。
 * <p>
 * 链接：https://leetcode.cn/problems/find-minimum-in-rotated-sorted-array/
 */
public class FindMin {
    /**
     * 判断区间是否已经有序
     *
     * 如果当前区间（由 left 到 right）是有序的（即 nums[left] < nums[right]），说明这个区间没有发生旋转，最小值一定是区间的第一个元素 nums[left]，所以直接返回它。
     * 计算中间索引
     *
     * 使用 int mid = left + (right - left) / 2; 计算中间索引，避免直接相加可能造成的溢出问题。
     * 判断最小值在哪个区间
     *
     * 左侧有序情况：如果 nums[mid] >= nums[left]，说明从 left 到 mid 是有序的，此时最小值不可能出现在有序部分，所以最小值一定在右半部分，因此更新 left = mid + 1。
     * 旋转点在左侧情况：如果 nums[mid] < nums[left]，说明中间部分处于旋转状态，即最小值可能出现在左半部分或就是 nums[mid]，因此将 right 更新为 mid。
     * 退出条件
     *
     * 循环在 left == right 时退出，此时 nums[left] 就是整个数组的最小值。
     * @param nums
     * @return
     */
    public int findMin(int[] nums) {
        int left = 0, right = nums.length - 1;
        while (left < right) {
            if (nums[left] < nums[right]) {
                return nums[left];
            }
            int mid = left + (right - left) / 2;
            if (nums[mid] >= nums[left]) {
                left = mid + 1;
            } else {
                right = mid;
            }
        }
        return nums[left];
    }

}
