package bitwise;
/**
 * 题目： 190. 颠倒二进制位 (addBinary)
 * 描述：颠倒给定的 32 位无符号整数的二进制位。
 *
 * 提示：
 *
 * 请注意，在某些语言（如 Java）中，没有无符号整数类型。在这种情况下，输入和输出都将被指定为有符号整数类型，并且不应影响您的实现，因为无论整数是有符号的还是无符号的，其内部的二进制表示形式都是相同的。
 * 在 Java 中，编译器使用二进制补码记法来表示有符号整数。因此，在 示例 2 中，输入表示有符号整数 -3，输出表示有符号整数 -1073741825。
 *
 * 示例 1：
 输入：n = 00000010100101000001111010011100
 输出：964176192 (00111001011110000010100101000000)
 解释：输入的二进制串 00000010100101000001111010011100 表示无符号整数 43261596，
 因此返回 964176192，其二进制表示形式为 00111001011110000010100101000000。

 * 链接：https://leetcode.cn/problems/reverse-bits/
 */
public class ReverseBits {
    /**
     * 逐位提取＋拼装
     *
     * 初始化一个结果变量 res = 0。
     * 对于原数 n 的每一位（共 32 位），从最低位到最高位做：
     * 先把 res 左移 1 位，为下一个要写入的位置腾出最低位。
     * 从 n 中取出当前的最低位 n & 1，把它或进 res。
     * 再把 n 无符号右移 1 位（>>>= 1），为下一轮提取准备。
     * 重复 32 次，最后 res 就是把原来 n 的二进制“倒过来”的结果。
     * @param n
     * @return
     */
    public int reverseBits(int n) {
        int res = 0;
        // 共处理 32 位
        for (int i = 0; i < 32; i++) {
            // 先把 res 左移，为下一位腾出最低位
            res <<= 1;
            // 取出 n 的最低位，或进 res 的最低位
            res |= (n & 1);
            // 无符号右移 n，推动下一位到最低位
            n >>>= 1;
        }
        return res;
    }
}
