package bitwise;
/**
 * 题目： 137. 只出现一次的数字 II (singleNumber)
 * 描述：给你一个整数数组 nums ，除某个元素仅出现 一次 外，其余每个元素都恰出现 三次 。请你找出并返回那个只出现了一次的元素。
 *
 * 你必须设计并实现线性时间复杂度的算法且使用常数级空间来解决此问题。
 *
 示例 1：
 输入：nums = [2,2,3,2]
 输出：3

 * 链接：https://leetcode.cn/problems/single-number-ii/
 */
//不会
public class SingleNumber2 {
    /**
     * 除了那唯一一个只出现一次的数，数组里其它每个数都出现了三次。把它们在二进制层面“叠加”起来，出现三次的数的每一位（0/1）
     * 在总和里都会是 0×3=0 或 1×3=3，而那个只出现一次的数的每一位则只加 0×1=0 或 1×1=1。于是：
     *
     * 统计所有数在第 i 位上 1 的个数，记作 count[i]。
     * count[i] % 3 要么是 0（说明那一位上只来自出现三次部分），要么是 1（说明唯一数在这一位上是 1）。
     * 把所有 count[i] % 3 按位重组，就得到了那个只出现一次的整数的二进制形式。
     * @param nums
     * @return
     */
    public int singleNumber(int[] nums) {
        // 用于统计 nums 中每一位上 1 出现的次数
        int[] bitCount = new int[32];

        // 累加所有数字的二进制位
        for (int num : nums) {
            for (int i = 0; i < 32; i++) {
                // 提取 num 的第 i 位：(num >>> i) & 1
                bitCount[i] += (num >>> i) & 1;
            }
        }

        // 重组只出现一次的那个数
        int result = 0;
        for (int i = 0; i < 32; i++) {
            // 如果 bitCount[i] % 3 == 1，说明唯一数的第 i 位为 1
            if (bitCount[i] % 3 != 0) {
                // 将第 i 位置为 1
                result |= (1 << i);
            }
        }

        return result;
    }
}
