package digit;
/**
 * 题目： 50. Pow(x, n) (myPow)
 * 描述：实现 pow(x, n) ，即计算 x 的整数 n 次幂函数（即，xn ）。
 *
 示例 1：
 输入：x = 2.00000, n = 10
 输出：1024.00000

 * 链接：https://leetcode.cn/problems/powx-n/
 */
//自己写的超时
public class MyPow {
    public double myPow(double x, int n) {
        // 0^任何正数 = 0； 任何数^0 = 1
        if (x == 0) return 0;
        if (n == 0) return 1;

        // 把 n 放到 long 里，避免 Integer.MIN_VALUE 取绝对值时溢出
        long N = n;
        if (N < 0) {
            x = 1 / x;   // 负指数取倒数
            N = -N;
        }

        double ans = 1.0;
        // 快速幂核心：二分法分解 N
        while (N > 0) {
            // 如果当前最低位是 1，就把当前 x 累乘进结果
            if ((N & 1) == 1) {
                ans *= x;
            }
            // x 翻倍：x = x^2, x^4, x^8, ...
            x *= x;
            // 指数右移，下一位变成最低位
            N >>= 1;
        }
        return ans;
    }
}
