package dynamic_programming;

import java.util.Arrays;

/**
 * 题目： 416. 分割等和子集 (CanPartition)
 * 描述：给你一个 只包含正整数 的 非空 数组 nums 。请你判断是否可以将这个数组分割成两个子集，使得两个子集的元素和相等。

 示例 2：
 输入：nums = [1,5,11,5]
 输出：true
 解释：数组可以分割成 [1, 5, 5] 和 [11] 。

 * 链接：https://leetcode.cn/problems/partition-equal-subset-sum/
 */
public class CanPartition {
    private void reverse(int[] nums) {
        int left = 0, right = nums.length - 1;
        while (left < right) {
            int tmp = nums[left];
            nums[left] = nums[right];
            nums[right] = tmp;
            left++;
            right--;
        }
    }
    private boolean backtrack(int[] nums, int target, int start) {
        // 若已经完全匹配到目标和，返回 true
        if (target == 0) {
            return true;
        }

        // 如果目标和已经小于0，说明该分支不可行，返回 false
        if (target < 0) {
            return false;
        }

        // 从 start 开始尝试使用后续的每个数
        for (int i = start; i < nums.length; i++) {
            // 若当前数字超过 target，则可以跳过
            if (nums[i] > target) {
                continue;
            }
            // 选择当前数字，并尝试凑出剩余的 target
            if (backtrack(nums, target - nums[i], i + 1)) {
                return true;
            }
        }
        return false;
    }
    //回溯法，超时了
    public boolean canPartition1(int[] nums) {
        // 计算数组总和
        int sum = 0;
        for (int num : nums) {
            sum += num;
        }

        // 如果总和为奇数，则不可能平分
        if (sum % 2 != 0) {
            return false;
        }

        // 目标值为总和的一半
        int target = sum / 2;

        // 对数组进行排序，为了后续剪枝和高效回溯，建议降序排列
        Arrays.sort(nums);
        reverse(nums);
        // 从第0个位置开始回溯，寻找是否有子集和为target
        return backtrack(nums, target, 0);
    }

    public boolean canPartition(int[] nums) {
        if(nums == null || nums.length == 0) return false;
        int n = nums.length;
        int sum = 0;
        for(int num : nums) {
            sum += num;
        }
        //总和为奇数，不能平分
        if(sum % 2 != 0) return false;
        int target = sum / 2;
        int[] dp = new int[target + 1];
        for(int i = 0; i < n; i++) {
            for(int j = target; j >= nums[i]; j--) {
                //物品 i 的重量是 nums[i]，其价值也是 nums[i]
                dp[j] = Math.max(dp[j], dp[j - nums[i]] + nums[i]);
            }

            //剪枝一下，每一次完成內層的for-loop，立即檢查是否dp[target] == target，優化時間複雜度（26ms -> 20ms）
            if(dp[target] == target)
                return true;
        }
        return dp[target] == target;
    }
}
