package dynamic_programming;
/**
 * 题目： 718. 最长重复子数组 (findLength)
 * 描述：给两个整数数组 nums1 和 nums2 ，返回 两个数组中 公共的 、长度最长的子数组的长度 。

 * 示例 1：
 输入：nums1 = [1,2,3,2,1], nums2 = [3,2,1,4,7]
 输出：3
 解释：长度最长的公共子数组是 [3,2,1] 。

 * 链接：https://leetcode.cn/problems/maximum-length-of-repeated-subarray/
 */
//不会

/**
 * dp[i][j] 的定义是：
 *
 * 以 nums1[i-1] 和 nums2[j-1] 作为“结尾”元素的两个前缀序列（分别是 nums1[0…i-1] 和 nums2[0…j-1]）的最长公共后缀（subarray）的长度。
 * 这样就可能出现dp[1][1]=1 dp[1][2]=0的情况了
 *
 * 状态转移方程
 * if (nums1[i-1] == nums2[j-1])
 *     dp[i][j] = dp[i-1][j-1] + 1;
 * else
 *     dp[i][j] = 0;
 */
public class FindLength {
    public int findLength(int[] nums1, int[] nums2) {
        int n = nums1.length, m = nums2.length;
        // dp[i][j] 表示 nums1[0..i-1] 与 nums2[0..j-1] '结尾'处的最长公共后缀长度
        int[][] dp = new int[n + 1][m + 1];
        int ans = 0;

        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= m; j++) {
                if (nums1[i - 1] == nums2[j - 1]) {
                    dp[i][j] = dp[i - 1][j - 1] + 1;
                    ans = Math.max(ans, dp[i][j]);
                }
                // else dp[i][j] 默认为 0
            }
        }
        return ans;
    }
}
