package dynamic_programming;
/**
 * 题目： 474. 一和零 (FindMaxForm)
 * 描述：给你一个二进制字符串数组 strs 和两个整数 m 和 n 。
 * 请你找出并返回 strs 的最大子集的长度，该子集中 最多 有 m 个 0 和 n 个 1 。
 * 如果 x 的所有元素也是 y 的元素，集合 x 是集合 y 的 子集 。

 示例 2：
 输入：strs = ["10", "0001", "111001", "1", "0"], m = 5, n = 3
 输出：4
 解释：最多有 5 个 0 和 3 个 1 的最大子集是 {"10","0001","1","0"} ，因此答案是 4 。
 其他满足题意但较小的子集包括 {"0001","1"} 和 {"10","1","0"} 。{"111001"} 不满足题意，因为它含 4 个 1 ，大于 n 的值 3 。

 * 链接：https://leetcode.cn/problems/ones-and-zeroes/
 */
public class FindMaxForm {
    int[] cnt(String str){
        int cntzero=0,cntone=0;
        for (int i = 0; i < str.length(); i++) {
            if(str.charAt(i)=='0')
                cntzero++;
            else cntone++;
        }
        return new int[]{cntzero,cntone};
    }
    public int findMaxForm(String[] strs, int m, int n) {
        int[][]dp=new int[m+1][n+1];  //最多m个0 n个1,能选取的字符串的个数  而不是组合数！
        for (String str : strs) {
            int[] res = cnt(str);
            for (int j = m; j >= res[0]; j--) {
                for (int k = n; k >= res[1]; k--) {
                    dp[j][k] =Math.max(dp[j][k],dp[j - res[0]][k - res[1]]+1);
                }
            }
        }
        return dp[m][n];
    }
}
