package dynamic_programming;
/**
 * 题目： 5. 最长回文子串 (longestPalindrome)
 * 描述：给你一个字符串 s，找到 s 中最长的 回文 子串。
 *

 * 示例 1：
 输入：s = "babad"
 输出："bab"
 解释："aba" 同样是符合题意的答案。

 * 链接：https://leetcode.cn/problems/longest-palindromic-substring/
 */
public class LongestPalindrome {
    public String longestPalindrome(String s) {
        int n = s.length();
        if (n < 2) return s;
        char[] cs = s.toCharArray();
        boolean[][] dp = new boolean[n][n];

        int maxLen = 1, start = 0;
        // 从后往前遍历 i，j 从 i 往后
        for (int i = n - 1; i >= 0; i--) {
            for (int j = i; j < n; j++) {
                // 回文条件：首尾相等，且要么长度<=2（两字符或单字符），要么内部也是回文
                if (cs[i] == cs[j] && (j - i <= 1 || dp[i + 1][j - 1])) {
                    dp[i][j] = true;
                    int len = j - i + 1;
                    if (len > maxLen) {
                        maxLen = len;
                        start = i;
                    }
                }
            }
        }
        return s.substring(start, start + maxLen);
    }
}
