package dynamic_programming;
/**
 * 题目： 516. 最长回文子序列 (longestPalindromeSubseq)
 * 描述：给你一个字符串 s ，找出其中最长的回文子序列，并返回该序列的长度。
 * 子序列定义为：不改变剩余字符顺序的情况下，删除某些字符或者不删除任何字符形成的一个序列。

 * 示例 1：
 输入：s = "bbbab"
 输出：4
 解释：一个可能的最长回文子序列为 "bbbb" 。

 * 链接：https://leetcode.cn/problems/longest-palindromic-subsequence/
 */
public class LongestPalindromeSubseq {
    public int longestPalindromeSubseq(String s) {
        int n = s.length();
        if (n < 2) return n;
        char[] cs = s.toCharArray();
        int[][] dp = new int[n][n];

        // 对角线全是长度 1 的子序列
        for (int i = 0; i < n; i++) {
            dp[i][i] = 1;
        }

        // i 从后往前，确保 dp[i+1][*] 已经算好
        for (int i = n - 1; i >= 0; i--) {
            for (int j = i + 1; j < n; j++) {
                if (cs[i] == cs[j]) {
                    dp[i][j] = dp[i + 1][j - 1] + 2;
                } else {
                    dp[i][j] = Math.max(dp[i + 1][j], dp[i][j - 1]);
                }
            }
        }
        return dp[0][n - 1];
    }
}
