package dynamic_programming;
/**
 * 题目： 123. 买卖股票的最佳时机 III (maxProfit)
 * 描述：给定一个数组，它的第 i 个元素是一支给定的股票在第 i 天的价格。
 *
 * 设计一个算法来计算你所能获取的最大利润。你最多可以完成 两笔 交易。
 *
 * 注意：你不能同时参与多笔交易（你必须在再次购买前出售掉之前的股票）。

 * 示例 1：
 输入：prices = [3,3,5,0,0,3,1,4]
 输出：6
 解释：在第 4 天（股票价格 = 0）的时候买入，在第 6 天（股票价格 = 3）的时候卖出，这笔交易所能获得利润 = 3-0 = 3 。
 随后，在第 7 天（股票价格 = 1）的时候买入，在第 8 天 （股票价格 = 4）的时候卖出，这笔交易所能获得利润 = 4-1 = 3 。

 * 链接：https://leetcode.cn/problems/best-time-to-buy-and-sell-stock-iii/
 */
//不会
public class MaxProfit3 {
    /**
     * 一天一共就有五个状态，
     *
     * 没有操作 （其实我们也可以不设置这个状态）
     * 第一次持有股票
     * 第一次不持有股票
     * 第二次持有股票
     * 第二次不持有股票
     * @param prices
     * @return
     */
    public int maxProfit(int[] prices) {
        int len = prices.length;
        // 边界判断, 题目中 length >= 1, 所以可省去
        if (prices.length == 0) return 0;

        /*
         * 定义 5 种状态:
         * 0: 没有操作, 1: 第一次买入, 2: 第一次卖出, 3: 第二次买入, 4: 第二次卖出
         */
        int[][] dp = new int[len][5];
        dp[0][1] = -prices[0];
        // 初始化第二次买入的状态是确保 最后结果是最多两次买卖的最大利润
        dp[0][3] = -prices[0];

        for (int i = 1; i < len; i++) {
            dp[i][1] = Math.max(dp[i - 1][1], -prices[i]);    //第一次持有股票
            dp[i][2] = Math.max(dp[i - 1][2], dp[i - 1][1] + prices[i]);   //第一次不持有股票
            dp[i][3] = Math.max(dp[i - 1][3], dp[i - 1][2] - prices[i]);   //第二次持有股票
            dp[i][4] = Math.max(dp[i - 1][4], dp[i - 1][3] + prices[i]);   //第二次不持有股票
        }

        return dp[len - 1][4];
    }
}
