package dynamic_programming;
/**
 * 题目： 309. 买卖股票的最佳时机含冷冻期 (maxProfit)
 * 描述：给定一个整数数组prices，其中第  prices[i] 表示第 i 天的股票价格 。​
 * 设计一个算法计算出最大利润。在满足以下约束条件下，你可以尽可能地完成更多的交易（多次买卖一支股票）:
 * 卖出股票后，你无法在第二天买入股票 (即冷冻期为 1 天)。
 * 注意：你不能同时参与多笔交易（你必须在再次购买前出售掉之前的股票）。

 * 示例 1：
 输入: prices = [1,2,3,0,2]
 输出: 3
 解释: 对应的交易状态为: [买入, 卖出, 冷冻期, 买入, 卖出]

 * 链接：https://leetcode.cn/problems/best-time-to-buy-and-sell-stock-with-cooldown/
 */
//不会
public class MaxProfit5 {
    public int maxProfit(int[] prices) {
        int n = prices.length;
        if (n == 0) return 0;

        // dp[i][0]: 持有股票
        // dp[i][1]: 不持有，且不在冷冻期（可买入/休息）
        // dp[i][2]: 今天卖出（刚卖出）
        // dp[i][3]: 今天冷冻期（昨天卖出）
        int[][] dp = new int[n][4];

        // 第 0 天的初始状态
        dp[0][0] = -prices[0];  // 买入
        dp[0][1] = 0;           // 空仓休息
        dp[0][2] = 0;           // 不可能刚卖出
        dp[0][3] = 0;           // 不可能处于冷冻期

        // 从第 1 天开始状态转移
        for (int i = 1; i < n; i++) {
            int p = prices[i];

            // 1. 持有股票：要么延续持有，要么从空仓/冷冻期买入
            dp[i][0] = Math.max(
                    dp[i-1][0],
                    Math.max(dp[i-1][1] - p, dp[i-1][3] - p)
            );

            // 2. 不持有且不在冷冻期：要么昨儿就休息，要么昨儿冷冻期结束
            dp[i][1] = Math.max(dp[i-1][1], dp[i-1][3]);

            // 3. 今天卖出：一定是从持有状态卖出
            dp[i][2] = dp[i-1][0] + p;

            // 4. 今天冷冻期：只能由昨天卖出进入
            dp[i][3] = dp[i-1][2];
        }

        // 最后一天不持有股票的三种状态取最大
        return Math.max(
                Math.max(dp[n-1][1], dp[n-1][2]),
                dp[n-1][3]
        );
    }
}
