package dynamic_programming;
/**
 * 题目： 746. 使用最小花费爬楼梯 (MinCostClimbingStairs)
 * 描述：给你一个整数数组 cost ，其中 cost[i] 是从楼梯第 i 个台阶向上爬需要支付的费用。一旦你支付此费用，即可选择向上爬一个或者两个台阶。
 * 你可以选择从下标为 0 或下标为 1 的台阶开始爬楼梯。
 * 请你计算并返回达到楼梯顶部的最低花费。

 示例 2：
 输入：cost = [10,15,20]
 输出：15
 解释：你将从下标为 1 的台阶开始。
 - 支付 15 ，向上爬两个台阶，到达楼梯顶部。
 总花费为 15 。

 * 链接：https://leetcode.cn/problems/min-cost-climbing-stairs/
 */
public class MinCostClimbingStairs {
    public int minCostClimbingStairs(int[] cost) {
        int n = cost.length;
        int[] dp = new int[n + 1];
        // 默认第一步和第二步不花费体力
        dp[0] = 0;
        dp[1] = 0;
        // 从第 2 阶开始，递推计算到顶楼
        for (int i = 2; i <= n; i++) {
            dp[i] = Math.min(dp[i - 1] + cost[i - 1], dp[i - 2] + cost[i - 2]);
        }
        return dp[n];
    }

    // 供测试使用的main方法
    public static void main(String[] args) {
        MinCostClimbingStairs sol = new MinCostClimbingStairs();
        int[] cost = {10, 15, 20};
        System.out.println("最低花费为: " + sol.minCostClimbingStairs(cost));
    }
}
