package dynamic_programming;
/**
 * 题目： 115. 不同的子序列 (numDistinct)
 * 描述：给你两个字符串 s 和 t ，统计并返回在 s 的 子序列 中 t 出现的个数。
 *
 * 测试用例保证结果在 32 位有符号整数范围内。

 示例 1：
 输入：s = "rabbbit", t = "rabbit"
 输出：3
 解释：
 如下所示, 有 3 种可以从 s 中得到 "rabbit" 的方案。
 rabbbit
 rabbbit
 rabbbit

 * 链接：https://leetcode.cn/problems/distinct-subsequences/
 */
//不会
public class NumDistinct {
    public int numDistinct(String s, String t) {
        int n = s.length(), m = t.length();
        // dp[i][j]: s[0..i-1] 中 t[0..j-1] 的方案数
        long[][] dp = new long[n+1][m+1];
        // 初始化
        for (int i = 0; i <= n; i++) {
            dp[i][0] = 1;
        }
        // dp[0][j>0] 默认就是 0

        // 状态转移
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= m; j++) {
                if (s.charAt(i-1) == t.charAt(j-1)) {
                    dp[i][j] = dp[i-1][j-1] + dp[i-1][j];
                } else {
                    dp[i][j] = dp[i-1][j];
                }
            }
        }
        // 由于题目保证答案在 32 位范围内，最后转为 int 返回
        return (int) dp[n][m];
    }
}
