package dynamic_programming;
/**
 * 题目： 96. 不同的二叉搜索树 (IntegerBreak)
 * 描述：给你一个整数 n ，求恰由 n 个节点组成且节点值从 1 到 n 互不相同的 二叉搜索树 有多少种？返回满足题意的二叉搜索树的种数。

 示例 2：
 输入：n = 3
 输出：5

 * 链接：https://leetcode.cn/problems/unique-binary-search-trees/
 */
//这道题要先推导，然后构建dp状态转移方程  不要被数值所困扰，就考虑左右子树有几个节点，分别能怎样排列组合
public class NumTrees {
    public int numTrees(int n) {
        // 定义dp数组，其中dp[i]表示由i个节点组成的不同二叉搜索树的个数
        int[] dp = new int[n + 1];

        // 初始化基础情况：空树和只有一个节点的树
        dp[0] = 1;  // 空树算一种
        dp[1] = 1;  // 单节点树只有一种

        // 自底向上逐步计算dp[i]
        // i代表当前要构造树的节点数
        for (int i = 2; i <= n; i++) {  //外层循环确保在计算 dp[i] 时，所有比 i 小的 dp 值已经算出。
            // 枚举所有可能的根节点（k从1到i）
            for (int k = 1; k <= i; k++) {
                // 左子树由 k - 1 个节点构成，右子树由 i - k 个节点构成  因为二叉搜索树，左子树中的节点一定小于根节点！！
                // 这两部分构造方式相互独立，因此总方法数相乘
                dp[i] += dp[k - 1] * dp[i - k];
            }
        }

        // 返回由n个节点组成的不同二叉搜索树个数
        return dp[n];
    }

    // 可用于简单测试
    public static void main(String[] args) {
        NumTrees solution = new NumTrees();
        int n = 3;
        int result = solution.numTrees(n);
        System.out.println("当 n = " + n + " 时，不同的二叉搜索树个数为：" + result); // 输出 5
    }
}
