package dynamic_programming;
/**
 * 题目： 213. 打家劫舍 II (rob)
 * 描述：你是一个专业的小偷，计划偷窃沿街的房屋，每间房内都藏有一定的现金。这个地方所有的房屋都 围成一圈 ，这意味着第一个房屋和最后一个房屋是紧挨着的。同时，相邻的房屋装有相互连通的防盗系统，如果两间相邻的房屋在同一晚上被小偷闯入，系统会自动报警 。
 * 给定一个代表每个房屋存放金额的非负整数数组，计算你 在不触动警报装置的情况下 ，今晚能够偷窃到的最高金额。
 *
 示例 2：
 输入：nums = [2,3,2]
 输出：3
 解释：你不能先偷窃 1 号房屋（金额 = 2），然后偷窃 3 号房屋（金额 = 2）, 因为他们是相邻的。

 * 链接：https://leetcode.cn/problems/house-robber-ii/
 */
public class Rob2 {
    public int rob(int[] nums) {
        int n = nums.length;
        if (n == 0) return 0;
        if (n == 1) return nums[0];
        // 情况一：不抢第一家，抢 [1..n-1]
        int max1 = robLinear(nums, 1, n - 1);
        // 情况二：不抢最后一家，抢 [0..n-2]
        int max2 = robLinear(nums, 0, n - 2);
        return Math.max(max1, max2);
    }

    // 经典线性打家劫舍，区间 [start..end]
    private int robLinear(int[] nums, int start, int end) {
        int prev2 = 0;         // dp[i-2]
        int prev1 = 0;         // dp[i-1]
        for (int i = start; i <= end; i++) {
            int curr = Math.max(prev1, prev2 + nums[i]);
            prev2 = prev1;
            prev1 = curr;
        }
        return prev1;
    }
}
