package graph;
/**
 * 题目： 133. 克隆图 (cloneGraph)
 * 描述：给你无向 连通 图中一个节点的引用，请你返回该图的 深拷贝（克隆）。
 *
 * 图中的每个节点都包含它的值 val（int） 和其邻居的列表（list[Node]）。
 *
 * class Node {
 *     public int val;
 *     public List<Node> neighbors;
 * }
 *
 * 差值是一个正数，其数值等于两值之差的绝对值。
 *
 示例 1：
 输入：adjList = [[2,4],[1,3],[2,4],[1,3]]
 输出：[[2,4],[1,3],[2,4],[1,3]]
 解释：
 图中有 4 个节点。
 节点 1 的值是 1，它有两个邻居：节点 2 和 4 。
 节点 2 的值是 2，它有两个邻居：节点 1 和 3 。
 节点 3 的值是 3，它有两个邻居：节点 2 和 4 。
 节点 4 的值是 4，它有两个邻居：节点 1 和 3 。

 * 链接：https://leetcode.cn/problems/clone-graph/
 */
//不会做
import graph.Node;

import java.util.ArrayList;
import java.util.HashMap;

public class CloneGraph {
    private HashMap<Node, Node> visited = new HashMap <> ();
    public Node cloneGraph(Node node) {
        if (node == null) {
            return node;
        }

        // 如果该节点已经被访问过了，则直接从哈希表中取出对应的克隆节点返回
        if (visited.containsKey(node)) {
            return visited.get(node);
        }

        // 克隆节点，注意到为了深拷贝我们不会克隆它的邻居的列表
        Node cloneNode = new Node(node.val, new ArrayList());
        // 哈希表存储
        visited.put(node, cloneNode);

        // 第一次 遇到某个邻居时，递归会深入——先把它自身拷贝出来（并加入 visited），再去拷贝它的邻居们……
        //如果再次遇到 同一个原节点（例如有环或多条路径到同一节点），就会走到第 2 步直接从 visited 里拿到已有的克隆节点，避免重复和死循环。
        for (Node neighbor: node.neighbors) {
            cloneNode.neighbors.add(cloneGraph(neighbor));
        }
        return cloneNode;
    }
}
