package graph;
/**
 * 题目： 733. 图像渲染 (floodFill)
 * 描述：有一幅以 m x n 的二维整数数组表示的图画 image ，其中 image[i][j] 表示该图画的像素值大小。你也被给予三个整数 sr ,  sc 和 color 。你应该从像素 image[sr][sc] 开始对图像进行上色 填充 。

 * 为了完成 上色工作：
 * 从初始像素开始，将其颜色改为 color。
 * 对初始坐标的 上下左右四个方向上 相邻且与初始像素的原始颜色同色的像素点执行相同操作。
 * 通过检查与初始像素的原始颜色相同的相邻像素并修改其颜色来继续 重复 此过程。
 * 当 没有 其它原始颜色的相邻像素时 停止 操作。
 * 最后返回经过上色渲染 修改 后的图像 。

 *
 * 示例 1：
 输入：image = [[1,1,1],[1,1,0],[1,0,1]]，sr = 1, sc = 1, color = 2
 输出：[[2,2,2],[2,2,0],[2,0,1]]

 * 链接：https://leetcode.cn/problems/flood-fill/
 */
public class FloodFill {
    void dfs(int[][] image,int[][] visited,int origin,int i,int j,int color){
        int r=image.length;
        int c=image[0].length;
        if(i<0||i>=r||j<0||j>=c||visited[i][j]==1||image[i][j]!=origin)
            return;
        image[i][j]=color;
        visited[i][j]=1;
        dfs(image,visited,origin,i-1,j,color);
        dfs(image,visited,origin,i+1,j,color);
        dfs(image,visited,origin,i,j-1,color);
        dfs(image,visited,origin,i,j+1,color);
    }
    public int[][] floodFill(int[][] image, int sr, int sc, int color) {
        int r=image.length;
        int c=image[0].length;
        int origin=image[sr][sc];
        int[][] visited=new int[r][c];
        dfs(image,visited,origin,sr,sc,color);
        return image;
    }
}
