package graph;

import java.util.*;

/**
 * 题目： 127. 单词接龙  (ladderLength)
 * 描述：字典 wordList 中从单词 beginWord 到 endWord 的 转换序列 是一个按下述规格形成的序列 beginWord -> s1 -> s2 -> ... -> sk：
 *
 * 每一对相邻的单词只差一个字母。
 *  对于 1 <= i <= k 时，每个 si 都在 wordList 中。注意， beginWord 不需要在 wordList 中。
 * sk == endWord
 * 给你两个单词 beginWord 和 endWord 和一个字典 wordList ，返回 从 beginWord 到 endWord 的 最短转换序列 中的 单词数目 。如果不存在这样的转换序列，返回 0 。
 *
 示例 1：
 输入：beginWord = "hit", endWord = "cog", wordList = ["hot","dot","dog","lot","log","cog"]
 输出：5
 解释：一个最短转换序列是 "hit" -> "hot" -> "dot" -> "dog" -> "cog", 返回它的长度 5。

 * 链接：https://leetcode.cn/problems/word-ladder/

 */
//和433. 最小基因变化雷同
public class LadderLength {
    public int ladderLength(String beginWord, String endWord, List<String> wordList) {
        Set<String>set=new HashSet<>(wordList);
        Set<String>visited=new HashSet<>();
        Queue<String> queue=new ArrayDeque<>();
        queue.add(beginWord);
        visited.add(beginWord);
        if(!set.contains(endWord))return 0;
        int steps=1;
        while (!queue.isEmpty()){
            int sz= queue.size();
            for (int i = 0; i < sz; i++) {
                String cur=queue.poll();
                if(cur.equals(endWord))
                    return steps;
                char[] currArr = cur.toCharArray();
                for (int pos = 0; pos < currArr.length; pos++) {
                    char old=currArr[pos];
                    for (int j = 0; j < 26; j++) {
                        char g= (char) ('a'+j);
                        currArr[pos]=g;
                        String next=new String(currArr);
                        if(set.contains(next)&&!visited.contains(next)){
                            visited.add(next);
                            queue.offer(next);
                        }
                    }
                    currArr[pos]=old;
                }
            }
            steps++;
        }
        return 0;
    }
}
