package graph;
/**
 * 题目： 695. 岛屿的最大面积  (maxAreaOfIsland)
 * 描述：给你一个大小为 m x n 的二进制矩阵 grid 。
 * 岛屿 是由一些相邻的 1 (代表土地) 构成的组合，这里的「相邻」要求两个 1 必须在 水平或者竖直的四个方向上 相邻。你可以假设 grid 的四个边缘都被 0（代表水）包围着。
 * 岛屿的面积是岛上值为 1 的单元格的数目。
 * 计算并返回 grid 中最大的岛屿面积。如果没有岛屿，则返回面积为 0 。

 * 链接：https://leetcode.cn/problems/max-area-of-island/

 */
public class MaxAreaOfIsland {
    int dfs(int[][] grid,int i,int j){
        if(i<0 || i>=grid.length || j<0 || j>=grid[0].length || grid[i][j]==0) {
            return 0;
        }
        int area = 1;
        grid[i][j]=0;
        area+=dfs(grid,i,j-1);
        area+=dfs(grid,i,j+1);
        area+=dfs(grid,i+1,j);
        area+=dfs(grid,i-1,j);
        return area;
    }
    public int maxAreaOfIsland(int[][] grid) {
        int maxx=0;
        for (int i = 0; i < grid.length; i++) {
            for (int j = 0; j < grid[0].length; j++) {
                if(grid[i][j]==1) {
                    int area = dfs(grid, i, j);
                    maxx = Math.max(maxx, area);
                }
            }
        }
        return maxx;
    }
}
