package graph;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

/**
 * 题目： 130. 被围绕的区域 (solve)
 * 描述：给你一个 m x n 的矩阵 board ，由若干字符 'X' 和 'O' 组成，捕获 所有 被围绕的区域：
 * 连接：一个单元格与水平或垂直方向上相邻的单元格连接。
 * 区域：连接所有 'O' 的单元格来形成一个区域。
 * 围绕：如果您可以用 'X' 单元格 连接这个区域，并且区域中没有任何单元格位于 board 边缘，则该区域被 'X' 单元格围绕。
 * 通过 原地 将输入矩阵中的所有 'O' 替换为 'X' 来 捕获被围绕的区域。你不需要返回任何值。
 * <p>
 * 示例 1：
 * 输入：board = [["X","X","X","X"],["X","O","O","X"],["X","X","O","X"],["X","O","X","X"]]
 * 输出：[["X","X","X","X"],["X","X","X","X"],["X","X","X","X"],["X","O","X","X"]]
 * <p>
 * 链接：https://leetcode.cn/problems/surrounded-regions/
 */
//做出来了，但是很繁琐1
public class Solve {
//    void dfs(char[][] board, Queue<int[]> queue, int i, int j) {
//        if (!judgeValid(board, i, j) || board[i][j] == 'X')
//            return;
//        queue.offer(new int[]{i, j});
//        board[i][j] = 'X';
//        dfs(board, queue, i - 1, j);
//        dfs(board, queue, i + 1, j);
//        dfs(board, queue, i, j - 1);
//        dfs(board, queue, i, j + 1);
////        board[i][j]='0';
//    }
//
//    public void solve(char[][] board) {
//        Queue<int[]> queue = new LinkedList<>();
//        List<Queue<int[]>> list = new ArrayList<>();
//        for (int i = 0; i < board.length; i++) {
//            for (int j = 0; j < board[0].length; j++) {
//                if (board[i][j] == 'O') {
//                    dfs(board, queue, i, j);
//                    list.add(new LinkedList<>(queue));
//                    queue.clear();
//                }
//            }
//        }
//        for (Queue<int[]> queue1 : list) {
//            int size = queue1.size();
//            boolean flag = false;
//            Queue<int[]> temp = new LinkedList<>(queue1);
//            for (int i = 0; i < size; i++) {
//                int[] tp = queue1.poll();
//                if (!judgeValid(board, tp[0]-1, tp[1])||!judgeValid(board, tp[0]+1, tp[1])||!judgeValid(board, tp[0], tp[1]-1)||!judgeValid(board, tp[0], tp[1]+1)) {
//                    flag = true;
//                    break;
//                }
//            }
//            if (flag) {
//                while (!temp.isEmpty()) {
//                    int[] tp = temp.poll();
//                    board[tp[0]][tp[1]] = 'O';
//                }
//            }
//            temp.clear();
//        }
//    }
//
//    boolean judgeValid(char[][] board, int i, int j) {
//        int r = board.length;
//        int c = board[0].length;
//        return i >= 0 && i < r && j >= 0 && j < c;
//    }


    public void solve(char[][] board) {
        if (board == null || board.length == 0) {
            return;
        }
        int rows = board.length, cols = board[0].length;
        // 从边界开始，将所有与边界相连的 'O' 标记为 '#'
        for (int i = 0; i < rows; i++) {
            dfs(board, i, 0);
            dfs(board, i, cols - 1);
        }
        for (int j = 0; j < cols; j++) {
            dfs(board, 0, j);
            dfs(board, rows - 1, j);
        }
        // 遍历整个矩阵，翻转剩余的 'O' 为 'X'，同时将标记 '#' 恢复为 'O'
        for (int i = 0; i < rows; i++) {
            for (int j = 0; j < cols; j++) {
                if (board[i][j] == 'O') {
                    board[i][j] = 'X';
                } else if (board[i][j] == '#') {
                    board[i][j] = 'O';
                }
            }
        }
    }

    private void dfs(char[][] board, int i, int j) {
        if (i < 0 || i >= board.length || j < 0 || j >= board[0].length || board[i][j] != 'O') {
            return;
        }
        board[i][j] = '#';
        dfs(board, i - 1, j);
        dfs(board, i + 1, j);
        dfs(board, i, j - 1);
        dfs(board, i, j + 1);
    }
}




