package greedy;
/**
 * 题目： 134. 加油站 (canCompleteCircuit)
 * 描述：在一条环路上有 n 个加油站，其中第 i 个加油站有汽油 gas[i] 升。
 * 你有一辆油箱容量无限的的汽车，从第 i 个加油站开往第 i+1 个加油站需要消耗汽油 cost[i] 升。你从其中的一个加油站出发，开始时油箱为空。
 * 给定两个整数数组 gas 和 cost ，如果你可以按顺序绕环路行驶一周，则返回出发时加油站的编号，否则返回 -1 。如果存在解，则 保证 它是 唯一 的。
 *
 * 示例 1：
 输入: gas = [1,2,3,4,5], cost = [3,4,5,1,2]
 输出: 3
 解释:
 从 3 号加油站(索引为 3 处)出发，可获得 4 升汽油。此时油箱有 = 0 + 4 = 4 升汽油
 开往 4 号加油站，此时油箱有 4 - 1 + 5 = 8 升汽油
 开往 0 号加油站，此时油箱有 8 - 2 + 1 = 7 升汽油
 开往 1 号加油站，此时油箱有 7 - 3 + 2 = 6 升汽油
 开往 2 号加油站，此时油箱有 6 - 4 + 3 = 5 升汽油
 开往 3 号加油站，你需要消耗 5 升汽油，正好足够你返回到 3 号加油站。
 因此，3 可为起始索引。

 * 链接：https://leetcode.cn/problems/gas-station/
 */
public class CanCompleteCircuit {
    public int canCompleteCircuit1(int[] gas, int[] cost) {
        int sumgas=0,sumcost=0;
        int[] diff=new int[gas.length];
        for (int i = 0; i < gas.length; i++) {
            sumgas+=gas[i];
            sumcost+=cost[i];
            diff[i]=gas[i]-cost[i];
        }
        if(sumcost>sumgas)
            return -1;
        for (int i = 0; i < diff.length; i++) {
            if(diff[i]>=0){
                int j=(i+1)%diff.length;
                int cur=diff[i];
                boolean flag=true;
                while(j!=i){
                    cur+=diff[j];
                    if(cur<0) {
                        flag=false;
                        break;
                    }
                    j=(j+1)%diff.length;
                }
                if(flag)
                    return i;
            }
        }
        return -1;
    }
    public int canCompleteCircuit(int[] gas, int[] cost) {
        int total = 0;   // 总盈余：记录所有加油站油量差值的总和
        int tank = 0;    // 当前油箱剩余：当前起点下的油量累计
        int start = 0;   // 起始加油站索引

        // 遍历所有加油站
        for (int i = 0; i < gas.length; i++) {
            // 当前加油站的油量差值：加油量 - 行驶消耗
            int diff = gas[i] - cost[i];
            // 累计总盈余
            total += diff;
            // 当前油箱剩余更新
            tank += diff;

            // 如果在当前起点，从起点到 i 的累计油量不足以到达 i+1，
            // 那么必然不能从该起点出发完成环路，所以把起点更新为 i+1，
            // 并且重置当前油箱剩余为 0
            if (tank < 0) {
                start = i + 1;
                tank = 0;
            }
        }

        // 如果总盈余小于 0，说明全局油量不足，返回 -1；否则返回更新后的起点
        return total < 0 ? -1 : start;
    }
}
