package greedy;

import java.util.Arrays;

/**
 * 题目： 55. 跳跃游戏 (canJump)
 * 描述：给你一个非负整数数组 nums ，你最初位于数组的 第一个下标 。数组中的每个元素代表你在该位置可以跳跃的最大长度。
 * 判断你是否能够到达最后一个下标，如果可以，返回 true ；否则，返回 false 。

 * 示例 1：
 输入：nums = [2,3,1,1,4]
 输出：true
 解释：可以先跳 1 步，从下标 0 到达下标 1, 然后再从下标 1 跳 3 步到达最后一个下标。

 * 链接：https://leetcode.cn/problems/jump-game/
 */
public class CanJump {
    //接近超时！记忆化搜索，记录每一个状态（这里是索引 i）是否能成功跳到最后。
    public boolean canJump1(int[] nums) {
        // -1 表示未计算，0 表示不能到达，1 表示能到达
        int[] memo = new int[nums.length];
        Arrays.fill(memo, -1);
        return helper(nums, 0, memo);
    }

    boolean helper(int[] nums, int i, int[] memo) {
        if (i >= nums.length - 1) return true;
        if (memo[i] != -1) return memo[i] == 1;  //-1代表没访问过，0代表失败，1代表成功

        int max = nums[i];
        for (int j = 1; j <= max; j++) {
            if (helper(nums, i + j, memo)) {
                memo[i] = 1;
                return true;
            }
        }
        memo[i] = 0;  //尝试了所有从当前位置 i 开始能跳的范围后，都没有跳到终点，说明从 i 出发是失败的。
        return false;
    }
    //太妙了！
    public boolean canJump(int[] nums) {
        int maxReach = 0; // 表示当前能到达的最远位置
        for (int i = 0; i < nums.length; i++) {
            // 如果当前位置超过了当前能到达的最远位置，则无法到达该位置，返回 false
            if (i > maxReach) {
                return false;
            }
            // 更新当前能到达的最远位置
            maxReach = Math.max(maxReach, i + nums[i]);
            // 如果能到达最后一个位置，则返回 true
            if (maxReach >= nums.length - 1) {
                return true;
            }
        }
        return false;
    }

}
