package greedy;
/**
 * 题目： 135. 分发糖果 (candy)
 * 描述：n 个孩子站成一排。给你一个整数数组 ratings 表示每个孩子的评分。
 * 你需要按照以下要求，给这些孩子分发糖果：
 * 每个孩子至少分配到 1 个糖果。
 * 相邻两个孩子评分更高的孩子会获得更多的糖果。
 * 请你给每个孩子分发糖果，计算并返回需要准备的 最少糖果数目 。

 示例 2：
 输入：ratings = [1,2,2]
 输出：4
 解释：你可以分别给第一个、第二个、第三个孩子分发 1、2、1 颗糖果。
 第三个孩子只得到 1 颗糖果，这满足题面中的两个条件。

 * 链接：https://leetcode.cn/problems/candy/
 */
//没想到，想复杂了
public class Candy {
    public int candy(int[] ratings) {
        int n = ratings.length;
        int[] candies = new int[n];

        // 第一步：初始化每个孩子至少1颗糖果
        for (int i = 0; i < n; i++) {
            candies[i] = 1;
        }

        // 第二步：从左到右遍历，如果右侧评分高，给右侧多1颗
        for (int i = 1; i < n; i++) {
            if (ratings[i] > ratings[i - 1]) {
                candies[i] = candies[i - 1] + 1;
            }
        }

        // 第三步：从右到左遍历，如果左侧评分高，确保左侧孩子糖果更多
        for (int i = n - 2; i >= 0; i--) {
            if (ratings[i] > ratings[i + 1]) {
                candies[i] = Math.max(candies[i], candies[i + 1] + 1);
            }
        }

        // 求出总糖果数
        int sum = 0;
        for (int candy : candies) {
            sum += candy;
        }

        return sum;
    }
}
