package greedy;

import java.util.Arrays;

/**
 * 题目： 1005. K 次取反后最大化的数组和 (largestSumAfterKNegations)
 * 描述：给你一个整数数组 nums 和一个整数 k ，按以下方法修改该数组：
 * 选择某个下标 i 并将 nums[i] 替换为 -nums[i] 。
 * 重复这个过程恰好 k 次。可以多次选择同一个下标 i 。
 * 以这种方式修改数组后，返回数组 可能的最大和 。
 *
 * 示例 1：
 输入：nums = [4,2,3], k = 1
 输出：5
 解释：选择下标 1 ，nums 变为 [4,-2,3] 。

 * 链接：https://leetcode.cn/problems/maximize-sum-of-array-after-k-negations/
 */
//有点绕
public class LargestSumAfterKNegations {
    //让绝对值大的负数变为正数，当前数值达到最大   那么如果将负数都转变为正数了，K依然大于0  只找数值最小的正整数进行反转
    public int largestSumAfterKNegations(int[] nums, int k) {
        if (nums.length == 1) return nums[0];

        // 排序：先把负数处理了
        Arrays.sort(nums);

        for (int i = 0; i < nums.length && k > 0; i++) { // 贪心点, 通过负转正, 消耗尽可能多的k
            if (nums[i] < 0) {
                nums[i] = -nums[i];
                k--;
            }
        }

        // 退出循环, k > 0 || k < 0 (k消耗完了不用讨论)
        if (k % 2 == 1) { // k > 0 && k is odd：对于负数：负-正-负-正
            Arrays.sort(nums); // 再次排序得到最小的正数
            nums[0] = -nums[0];
        }
        // k > 0 && k is even，flip数字不会产生影响: 对于负数: 负-正-负；对于正数：正-负-正

        int sum = 0;
        for (int num : nums) { // 计算最大和
            sum += num;
        }
        return sum;
    }
}
