package greedy;
/**
 * 题目： 123. 买卖股票的最佳时机 III (maxProfit)
 * 描述：给定一个数组，它的第 i 个元素是一支给定的股票在第 i 天的价格。
 *
 * 设计一个算法来计算你所能获取的最大利润。你最多可以完成 两笔 交易。
 *
 * 注意：你不能同时参与多笔交易（你必须在再次购买前出售掉之前的股票）。

 * 示例 1：
 输入：prices = [3,3,5,0,0,3,1,4]
 输出：6
 解释：在第 4 天（股票价格 = 0）的时候买入，在第 6 天（股票价格 = 3）的时候卖出，这笔交易所能获得利润 = 3-0 = 3 。
 随后，在第 7 天（股票价格 = 1）的时候买入，在第 8 天 （股票价格 = 4）的时候卖出，这笔交易所能获得利润 = 4-1 = 3 。

 * 链接：https://leetcode.cn/problems/best-time-to-buy-and-sell-stock-iii/
 */
//不会 困难题

public class MaxProfit3 {
    /**
     * 举个小例子 prices = [1, 5, 2, 6]（共 4 天）：
     *
     * 左半段你能算出 left = [0, 4, 4, 5]。
     * 右半段：
     * 以 i=2（价格 2）为起点：未来最高是 6，利润 = 6−2 = 4。
     * 以 i=1（价格 5）为起点：未来最高同样 6，利润 = 6−5 = 1。
     * 以 i=0（价格 1）为起点：未来最高 6，利润 = 6−1 = 5。
     *  right= [5,1,4,0]
     * 左半段维护minPrice 右半段维护maxPrice
     * @param prices
     * @return
     */
    public int maxProfit(int[] prices) {
        int n = prices.length;
        if (n < 2) return 0;                              // (1)

        // 1. left[i]: 0…i 天内最多一笔交易的最优收益
        int[] left = new int[n];
        int minPrice = prices[0];                         // (2)
        for (int i = 1; i < n; i++) {
            minPrice = Math.min(minPrice, prices[i]);     // (3) 更新最低买入价
            left[i] = Math.max(left[i - 1],               // (4) 选「不做新交易」或「今天卖出」
                    prices[i] - minPrice);
        }

        // 2. right[i]: i…n-1 天内最多一笔交易的最优收益
        int[] right = new int[n + 1];                     // (5) 右边界额外留 1，用于 i=n-1 时访问
        int maxPrice = prices[n - 1];                     // (6)
        for (int i = n - 1; i >= 0; i--) {
            maxPrice = Math.max(maxPrice, prices[i]);     // (7) 更新最高卖出价
            right[i] = Math.max(right[i + 1],             // (8) 选「不做新交易」或「今天买入后再卖出」
                    maxPrice - prices[i]);
        }

        // 3. 枚举切分点：第一笔结束在 i，第二笔从 i+1 开始
        int ans = 0;
        for (int i = -1; i < n; i++) {                    // (9)
            int leftProfit  = (i >= 0) ? left[i] : 0;     // (10)
            int rightProfit = (i + 1 < n) ? right[i + 1] : 0; // (11)
            ans = Math.max(ans, leftProfit + rightProfit);   // (12)
        }
        return ans;                                       // (13)
    }
}
