package greedy;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * 题目： 763. 划分字母区间 (partitionLabels)
 * 描述：给你一个字符串 s 。我们要把这个字符串划分为尽可能多的片段，同一字母最多出现在一个片段中。例如，字符串 "ababcc" 能够被分为 ["abab", "cc"]，但类似 ["aba", "bcc"] 或 ["ab", "ab", "cc"] 的划分是非法的。
 * 注意，划分结果需要满足：将所有划分结果按顺序连接，得到的字符串仍然是 s 。
 * 返回一个表示每个字符串片段的长度的列表。

 示例 2：
 输入：s = "ababcbacadefegdehijhklij"
 输出：[9,7,8]
 解释：
 划分结果为 "ababcbaca"、"defegde"、"hijhklij" 。
 每个字母最多出现在一个片段中。
 像 "ababcbacadefegde", "hijhklij" 这样的划分是错误的，因为划分的片段数较少。

 * 链接：https://leetcode.cn/problems/partition-labels/
 */
public class PartitionLabels {
    /**
     * 可以通过，但是时间复杂度高！
     预先计算字符最后出现位置
     一种常见且高效的做法是在遍历字符串前，用一个 Map<Character, Integer> 或者数组记录下每个字符的最后出现索引。这样，在后续遍历时，能够通过字符直接查到其最后出现位置，避免重复扫描。

     维护当前区间右边界
     在遍历过程中，维护一个 end 变量表示当前区间内所有字符最后出现位置的最大值。每遇到一个新的字符，就更新 end = Math.max(end, lastIndex[当前字符])。当遍历索引等于 end 时，说明当前区间已经完整，可以结束分区并记录长度。

     简化逻辑避免重复循环
     采用上述方法后，代码只需要一次遍历即可确定所有分区长度，无需额外遍历区间内所有字符进行检查。
     */
    public List<Integer> partitionLabels1(String s) {
        HashMap<Character,Integer>map=new HashMap<>();
        List<Integer>list=new ArrayList<>();
        for (int i = 0; i < s.length(); i++) {
            map.put(s.charAt(i),map.getOrDefault(s.charAt(i),0)+1);
        }
        StringBuffer buffer=new StringBuffer();
        for (int i = 0; i < s.length(); i++) {
            boolean flag=true;
            char cur=s.charAt(i);
            buffer.append(cur);
            int newCount = map.get(cur) - 1;
            if (newCount > 0) {
                map.put(cur, newCount);
            } else {
                map.remove(cur);
            }
            for (int j = 0; j < buffer.length(); j++) {
                if (map.containsKey(buffer.charAt(j))) {
                    flag = false;
                    break;
                }
            }
            if(flag) {
                list.add(buffer.length());
                buffer.setLength(0);
            }
        }
        return list;
    }
    //看这个
    public List<Integer> partitionLabels(String s) {
        // 用于记录每个字符最后一次出现的索引
        HashMap<Character, Integer> lastOccurrence = new HashMap<>();
        for (int i = 0; i < s.length(); i++) {
            lastOccurrence.put(s.charAt(i), i);
        }

        List<Integer> partitionSizes = new ArrayList<>();
        int start = 0, end = 0; // start 记录当前分区开始的位置

        for (int i = 0; i < s.length(); i++) {
            // 更新当前分区的最远截止位置
            end = Math.max(end, lastOccurrence.get(s.charAt(i)));
            // 当遍历到分区的最远截止位置时，说明可以划分一个区间
            if (i == end) {
                partitionSizes.add(end - start + 1);
                start = i + 1;  // 下一分区的起始位置
            }
        }

        return partitionSizes;
    }
}
