package hash;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * 题目： 205. 同构字符串 (isIsomorphic
 * 描述：给定两个字符串 s 和 t ，判断它们是否是同构的。
 * 如果 s 中的字符可以按某种映射关系替换得到 t ，那么这两个字符串是同构的。
 * 每个出现的字符都应当映射到另一个字符，同时不改变字符的顺序。不同字符不能映射到同一个字符上，相同字符只能映射到同一个字符上，字符可以映射到自己本身。
 *
 * 示例 1：
 输入：s = "egg", t = "add"
 输出：true

 * 链接：https://leetcode.cn/problems/isomorphic-strings/
 */
public class IsIsomorphic {
    public boolean isIsomorphic(String s, String t) {
        int cnt=s.length();
        if(cnt!=t.length())
            return false;
        Map<Character,Character>map1=new HashMap<>();
        Map<Character,Character>map2=new HashMap<>();
        for (int i = 0; i < cnt; i++) {
            char curs=s.charAt(i),curt=t.charAt(i);
            if(!map1.containsKey(curs)&&!map2.containsKey(curt)) {
                map1.put(curs, curt);
                map2.put(curt,curs);
            }
            else if(!map1.containsKey(curs)&&map2.containsKey(curt)||map1.containsKey(curs)&&!map2.containsKey(curt))
                return false;
            else{
                if(!map1.get(curs).equals(curt))
                    return false;
            }
        }
        return true;
    }

    public boolean isIsomorphic2(String s, String t) {
        int n = s.length();
        if (n != t.length()) return false;

        Map<Character, Character> map = new HashMap<>(n);
        Set<Character> used = new HashSet<>(n);

        for (int i = 0; i < n; i++) {
            char cs = s.charAt(i), ct = t.charAt(i);

            if (map.containsKey(cs)) {
                // 已有映射，检查一致性
                if (map.get(cs) != ct) return false;
            } else {
                // 新的映射，确保 ct 还没被用过
                if (used.contains(ct)) return false;
                map.put(cs, ct);
                used.add(ct);
            }
        }
        return true;
    }
}
