package heap;

import java.util.Comparator;
import java.util.PriorityQueue;

/**
 * 题目： 215. 数组中的第K个最大元素 (findKthLargest)
 * 描述：给定整数数组 nums 和整数 k，请返回数组中第 k 个最大的元素。
 * 请注意，你需要找的是数组排序后的第 k 个最大的元素，而不是第 k 个不同的元素。
 * 你必须设计并实现时间复杂度为 O(n) 的算法解决此问题。
 *
 * 示例 1：
 输入: [3,2,1,5,6,4], k = 2
 输出: 5

 * 链接：https://leetcode.cn/problems/kth-largest-element-in-an-array/
 */
public class FindKthLargest {
    //完全填满堆再删除元素  最大堆
    public int findKthLargest1(int[] nums, int k) {
        PriorityQueue<Integer>maxheap=new PriorityQueue<>(Comparator.reverseOrder());
        for (int num : nums) {
            maxheap.add(num);
        }
        for (int i = 0; i < k-1; i++) {
            maxheap.poll();
        }
        return maxheap.peek();
    }
    //使用最小堆来存储前 k 个最大的元素。堆顶元素是 k 个最大元素中的最小值。这样，堆的大小始终保持为 k。当堆的大小大于 k 时，弹出堆顶元素。最终堆顶元素就是第 k 大的元素。不需要完全填满堆再删除元素：
    public int findKthLargest2(int[] nums, int k) {
        // 使用最小堆
        PriorityQueue<Integer> minHeap = new PriorityQueue<>();

        // 遍历数组
        for (int num : nums) {
            // 如果堆的大小小于 k，直接加入元素
            if (minHeap.size() < k) {
                minHeap.add(num);
            } else if (num > minHeap.peek()) {
                // 如果堆的大小已达到 k，且当前元素大于堆顶元素，则替换堆顶
                minHeap.poll();
                minHeap.add(num);
            }
        }

        // 返回堆顶元素，即为第 k 大的元素
        return minHeap.peek();
    }
    //快速选择
    public int quickselect(int[] nums, int l, int r, int k) {
        // 当区间内只有一个元素时，直接返回该元素
        if (l >= r) {
            return nums[l];
        }
        // 选取区间第一个元素作为枢轴
        int pivot = nums[l];
        int i = l, j = r;

        // 分区过程：调整数组，使得左侧的元素不大于枢轴，右侧的元素不小于枢轴
        while (i < j) {
            // 从右边向左扫描，找到第一个小于 pivot 的元素，放到左侧
            while (i < j && nums[j] >= pivot) {
                j--;
            }
            nums[i] = nums[j];
            // 从左边向右扫描，找到第一个大于 pivot 的元素，放到右侧
            while (i < j && nums[i] <= pivot) {
                i++;
            }
            nums[j] = nums[i];
        }
        // 将枢轴放入正确的位置
        nums[i] = pivot;

        // 现在 i 即为枢轴位置
        if (i == k) {
            return nums[i];
        } else if (k < i) {
            return quickselect(nums, l, i - 1, k);
        } else {
            return quickselect(nums, i + 1, r, k);
        }
    }
    public int findKthLargest(int[] _nums, int k) {
        int n = _nums.length;
        return quickselect(_nums, 0, n - 1, n - k);
    }
}
