package linkedlist;

import java.util.HashSet;

/**
 * 题目： 141. 环形链表  (hasCycle)
 * 描述：给你一个链表的头节点 head ，判断链表中是否有环。
 * 如果链表中有某个节点，可以通过连续跟踪 next 指针再次到达，则链表中存在环。 为了表示给定链表中的环，评测系统内部使用整数 pos 来表示链表尾连接到链表中的位置（索引从 0 开始）。注意：pos 不作为参数进行传递 。仅仅是为了标识链表的实际情况。
 * 如果链表中存在环 ，则返回 true 。 否则，返回 false 。

 * 链接：https://leetcode.cn/problems/linked-list-cycle/
 输入：head = [3,2,0,-4], pos = 1
 输出：true
 解释：链表中有一个环，其尾部连接到第二个节点。
 */
public class HasCycle {
    //哈希法
    public boolean hasCycle1(ListNode head) {
        HashSet<ListNode>set=new HashSet<>();
        ListNode temp=head;
        while (temp!=null) {
            if (!set.contains(temp))
                set.add(temp);
            else
                return true;
            temp = temp.next;
        }
        return false;
    }
    //翻转指针
    public boolean hasCycle2(ListNode head) {
        // 如果链表为空或者只有一个节点，直接返回无环
        if (head == null || head.next == null) {
            return false;
        }

        // 用 originalHead 保存最初的头节点
        ListNode originalHead = head;
        // 从 head.next 开始遍历，先把 head 与链表分离
        ListNode cur = head.next;
        ListNode pre = head;
        // 断开 head 和后面的连接
        head.next = null;

        while (cur != null) {
            // 如果当前节点又指回了 originalHead，则说明出现环
            if (cur == originalHead) {
                return true;
            }
            // 反转指针
            ListNode temp = cur.next;
            cur.next = pre;
            // 移动 pre 和 cur
            pre = cur;
            cur = temp;
        }

        // 走到空指针，说明无环
        return false;
    }
    public boolean hasCycle(ListNode head) {
        if (head == null || head.next == null) {
            return false;
        }
        ListNode slow = head;
        ListNode fast = head.next;
        while (slow != fast) {
            if (fast == null || fast.next == null) {
                return false;
            }
            slow = slow.next;
            fast = fast.next.next;
        }
        return true;
    }
}
