package linkedlist;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目：234. 回文链表  (isPalindrome)
 * 描述：给你一个单链表的头节点 head ，请你判断该链表是否为回文链表。如果是，返回 true ；否则，返回 false 。

 * 链接：https://leetcode.cn/problems/palindrome-linked-list/

 */
public class IsPalindrome {
    public boolean isPalindrome(ListNode head) {
        ListNode temp=head;
        List<Integer>list=new ArrayList<>();
        while (head!=null){
            list.add(head.val);
            head=head.next;
        }
        int size=list.size();
        for (int i = 0; i < size; i++) {
            if(list.get(i)!=list.get(size-1-i))
                return false;
        }
        return true;
    }
    //快慢指针 + 链表反转
    public boolean isPalindrome1(ListNode head) {
        if (head == null || head.next == null) {
            return true; // 空链表或只有一个节点，直接返回 true
        }

        // 1. 快慢指针找到链表中点
        ListNode slow = head;
        ListNode fast = head;
        while (fast != null && fast.next != null) {
            slow = slow.next;
            fast = fast.next.next;
        }
        ReverseList reverseList = new ReverseList();
        // 2. 反转后半部分链表
        ListNode secondHalf = reverseList.reverseList(slow);

        // 3. 比较前后两部分链表
        ListNode p1 = head;
        ListNode p2 = secondHalf;
        while (p2 != null) {
            if (p1.val != p2.val) {
                return false;
            }
            p1 = p1.next;
            p2 = p2.next;
        }

        return true;
    }
}
