package linkedlist;

import java.util.*;

/**
 * 题目： 86. 分隔链表 (partition)
 * 描述：给你一个链表的头节点 head 和一个特定值 x ，请你对链表进行分隔，使得所有 小于 x 的节点都出现在 大于或等于 x 的节点之前。
 * 你应当 保留 两个分区中每个节点的初始相对位置。

 示例 1：
 输入：head = [1,4,3,2,5,2], x = 3
 输出：[1,2,2,4,3,5]

 * 链接：https://leetcode.cn/problems/partition-list/
 */
public class Partition {
    public ListNode partition(ListNode head, int x) {
        // 虚拟头
        ListNode smallDummy = new ListNode(0), largeDummy = new ListNode(0);
        ListNode small = smallDummy, large = largeDummy;

        // 一次遍历，分拆到两条链
        while (head != null) {
            if (head.val < x) {
                small.next = head;
                small = small.next;
            } else {
                large.next = head;
                large = large.next;
            }
            head = head.next;
        }
        // 断开“>=x”链尾，避免环
        large.next = null;
        // 拼接两部分
        small.next = largeDummy.next;

        return smallDummy.next;
    }
}
