package linkedlist;
/**
 * 题目： 92. 反转链表 II (reverseBetween)
 * 描述：给你单链表的头指针 head 和两个整数 left 和 right ，其中 left <= right 。请你反转从位置 left 到位置 right 的链表节点，返回 反转后的链表 。

 示例 2：
 输入：head = [1,2,3,4,5], left = 2, right = 4
 输出：[1,4,3,2,5]

 * 链接：https://leetcode.cn/problems/reverse-linked-list-ii/
 */
//不会一次遍历来翻转
public class ReverseBetween {
    private void reverseLinkedList(ListNode head) {
        // 也可以使用递归反转一个链表
        ListNode pre = null;
        ListNode cur = head;

        while (cur != null) {
            ListNode next = cur.next;
            cur.next = pre;
            pre = cur;
            cur = next;
        }
    }
    //遍历两次，先找两个切断的点left和right，再对内部翻转，再拼接
    public ListNode reverseBetween2(ListNode head, int left, int right) {
        // 因为头节点有可能发生变化，使用虚拟头节点可以避免复杂的分类讨论
        ListNode dummyNode = new ListNode(-1);
        dummyNode.next = head;

        ListNode pre = dummyNode;
        // 第 1 步：从虚拟头节点走 left - 1 步，来到 left 节点的前一个节点
        // 建议写在 for 循环里，语义清晰
        for (int i = 0; i < left - 1; i++) {
            pre = pre.next;
        }

        // 第 2 步：从 pre 再走 right - left + 1 步，来到 right 节点
        ListNode rightNode = pre;
        for (int i = 0; i < right - left + 1; i++) {
            rightNode = rightNode.next;
        }

        // 第 3 步：切断出一个子链表（截取链表）
        ListNode leftNode = pre.next;
        ListNode curr = rightNode.next;

        // 注意：切断链接
        pre.next = null;
        rightNode.next = null;

        // 第 4 步：同第 206 题，反转链表的子区间
        reverseLinkedList(leftNode);

        // 第 5 步：接回到原来的链表中
        pre.next = rightNode;
        leftNode.next = curr;
        return dummyNode.next;
    }
    //头插法反转
    public ListNode reverseBetween(ListNode head, int left, int right) {
        // 1. 创建哨兵节点，简化边界处理（当 left = 1 时，也能统一处理）
        ListNode dummyNode = new ListNode(-1);
        dummyNode.next = head;

        // 2. pre 最终要指向待反转区间的前一个节点：第 left−1 个节点
        ListNode pre = dummyNode;
        //    走 left−1 步，停在第 left−1 个节点上
        for (int i = 0; i < left - 1; i++) {
            pre = pre.next;
        }

        // 3. cur 指向第 left 个节点，也就是待反转区间的第一个节点
        ListNode cur = pre.next;
        // next 用于临时保存 cur.next 节点
        ListNode next;

        // 4. 头插法：将 [left+1, right] 之间的节点依次“摘下”并插入到 pre 之后
        //    需要执行 right−left 次操作，才能把区间内所有节点都移动到前面
        for (int i = 0; i < right - left; i++) {
            // 4.1 取出要移动的节点
            next = cur.next;
            // 4.2 将 next 从原位置摘除：让 cur 跳过 next
            cur.next = next.next;
            // 4.3 将 next 插到 pre 之后（即已反转部分的头部）
            next.next = pre.next;
            pre.next = next;
            //（cur 不动，next 每次都变成下一个要插入的节点）
        }

        // 5. 返回新的链表头
        return dummyNode.next;
    }
}
