package linkedlist;
/**
 * 题目： 61. 旋转链表 (rotateRight)
 * 描述：给你一个链表的头节点 head ，旋转链表，将链表每个节点向右移动 k 个位置。

 示例 1：
 输入：head = [1,2,3,4,5], k = 2
 输出：[4,5,1,2,3]

 * 链接：https://leetcode.cn/problems/rotate-list/
 */
public class RotateRight {
    public ListNode rotateRight(ListNode head, int k) {
        if (head == null || head.next == null || k == 0) {
            return head;
        }
        // 1. 先遍历一遍，求长度并连接成环
        ListNode tail = head;
        int n = 1;
        while (tail.next != null) {
            tail = tail.next;
            n++;
        }
        // 如果 k 对 n 取余后是 0，旋转后还是原链表
        int r = k % n;
        if (r == 0) {
            return head;
        }
        tail.next = head;  // 形成环

        // 2. 找到新尾：走 (n - r - 1) 步
        int stepsToNewTail = n - r;
        ListNode newTail = head;
        for (int i = 1; i < stepsToNewTail; i++) {
            newTail = newTail.next;
        }
        // 3. 新头是新尾的下一个节点
        ListNode newHead = newTail.next;
        // 4. 断开环
        newTail.next = null;

        return newHead;
    }
}
