package matrix;
/**
 * 题目： 289. 生命游戏 (GameOfLife)
 * 描述：根据 百度百科 ， 生命游戏 ，简称为 生命 ，是英国数学家约翰·何顿·康威在 1970 年发明的细胞自动机。
 *
 * 给定一个包含 m × n 个格子的面板，每一个格子都可以看成是一个细胞。每个细胞都具有一个初始状态： 1 即为 活细胞 （live），或 0 即为 死细胞 （dead）。每个细胞与其八个相邻位置（水平，垂直，对角线）的细胞都遵循以下四条生存定律：
 *
 * 如果活细胞周围八个位置的活细胞数少于两个，则该位置活细胞死亡；
 * 如果活细胞周围八个位置有两个或三个活细胞，则该位置活细胞仍然存活；
 * 如果活细胞周围八个位置有超过三个活细胞，则该位置活细胞死亡；
 * 如果死细胞周围正好有三个活细胞，则该位置死细胞复活；
 * 下一个状态是通过将上述规则同时应用于当前状态下的每个细胞所形成的，其中细胞的出生和死亡是 同时 发生的。给你 m x n 网格面板 board 的当前状态，返回下一个状态。
 *
 * 给定当前 board 的状态，更新 board 到下一个状态。
 *
 * 注意 你不需要返回任何东西。
 *
 * 示例 1：
 输入：board = [[0,1,0],[0,0,1],[1,1,1],[0,0,0]]
 输出：[[0,0,0],[1,0,1],[0,1,1],[0,1,0]]

 * 链接：https://leetcode.cn/problems/game-of-life/
 */
public class GameOfLife {
    //需要额外空间的解法
    void judge(int[][] board,int[][]res,int i,int j){
        int[]a={-1,0,1},b={-1,0,1};
        int cntoflive=0;
        for (int item : a) {
            for (int value : b) {
                if (item == 0 && value == 0) continue;
                int curi = i + item, curj = j + value;
                if (curi < 0 || curi >= board.length || curj < 0 || curj >= board[0].length) continue;
                if (board[curi][curj] == 1)
                    cntoflive++;
            }
        }
        if(cntoflive<2||cntoflive>3)
            res[i][j]=0;
        else if(board[i][j]==0&&cntoflive==3)
            res[i][j]=1;
        else res[i][j]=board[i][j];
    }
    public void gameOfLife1(int[][] board) {
        int[][]res=new int[board.length][board[0].length];
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[0].length; j++) {
                judge(board,res,i,j);
            }
        }
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[0].length; j++) {
                board[i][j]=res[i][j];
            }
        }
    }

    /**
     *  //O(1)空间解法：
     * 用 -1 表示：原来是活（1），下一代死（0）。
     * 用 2 表示：原来是死（0），下一代活（1）。
     *
     * 这样第一遍遍历时，根据规则把要“死”的活细胞置 -1，把要“生”的死细胞置 2；第二遍遍历时，凡是 >0 的都置 1，其余都置 0 即完成更新。
     * @param board
     */
    public void gameOfLife(int[][] board) {
        int m = board.length, n = board[0].length;
        int[] dirs = {-1, 0, 1};

        // 第一遍：标记所有要翻转状态的格子
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                int liveNeighbors = 0;
                // 数周围 8 个格子的原始「活」状态
                for (int dx : dirs) {
                    for (int dy : dirs) {
                        if (dx == 0 && dy == 0) continue;
                        int x = i + dx, y = j + dy;
                        if (x >= 0 && x < m && y >= 0 && y < n) {
                            // 原始活细胞是 1 或者标记为 -1（原来活后要死）
                            if (board[x][y] == 1 || board[x][y] == -1) {
                                liveNeighbors++;
                            }
                        }
                    }
                }

                // 当前是活细胞
                if (board[i][j] == 1) {
                    if (liveNeighbors < 2 || liveNeighbors > 3) {
                        // 活→死，暂标 -1
                        board[i][j] = -1;
                    }
                }
                // 当前是死细胞
                else if (board[i][j] == 0) {
                    if (liveNeighbors == 3) {
                        // 死→活，暂标 2
                        board[i][j] = 2;
                    }
                }
            }
        }

        // 第二遍：把所有格子“归一化”为 0/1
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                board[i][j] = board[i][j] > 0 ? 1 : 0;
            }
        }
    }
}
