package matrix;

/**
 * 题目： 36. 有效的数独 (IsValidSudoku)
 * 描述：请你判断一个 9 x 9 的数独是否有效。只需要 根据以下规则 ，验证已经填入的数字是否有效即可。
 *
 * 数字 1-9 在每一行只能出现一次。
 * 数字 1-9 在每一列只能出现一次。
 * 数字 1-9 在每一个以粗实线分隔的 3x3 宫内只能出现一次。（请参考示例图）
 *注意：
 *
 * 一个有效的数独（部分已被填充）不一定是可解的。
 * 只需要根据以上规则，验证已经填入的数字是否有效即可。
 * 空白格用 '.' 表示。
 *
 * 示例 1：
 输入：board =
 [["5","3",".",".","7",".",".",".","."]
 ,["6",".",".","1","9","5",".",".","."]
 ,[".","9","8",".",".",".",".","6","."]
 ,["8",".",".",".","6",".",".",".","3"]
 ,["4",".",".","8",".","3",".",".","1"]
 ,["7",".",".",".","2",".",".",".","6"]
 ,[".","6",".",".",".",".","2","8","."]
 ,[".",".",".","4","1","9",".",".","5"]
 ,[".",".",".",".","8",".",".","7","9"]]
 输出：true

 * 链接：https://leetcode.cn/problems/valid-sudoku/
 */
//没做出来
public class IsValidSudoku {
    /**
     * 跳过空格
     * 对于字符 '.' 直接 continue。
     *
     * 行列宫格索引映射
     *
     * 行：用 rows[i][num] 表示第 i 行数字 num 是否出现过。
     * 列：用 cols[j][num] 表示第 j 列数字 num 是否出现过。
     * 宫格：把 9×9 拆成 9 个 3×3 宫格，第 boxIndex = (i/3)*3 + (j/3)，用 boxes[boxIndex][num] 表示该宫格数字 num 是否出现过。
     * 一次遍历
     * 只需对整个板子扫一遍，遇到数字就检查对应的三张「表」里是否已标记：
     *
     * 已标记 → 返回 false
     * 未标记 → 标记为已出现，继续扫描
     * 遍历结束仍未发现冲突 → 返回 true
     * @param board
     * @return
     */
    public boolean isValidSudoku(char[][] board) {
        // 9 行 9 列
        boolean[][] rows   = new boolean[9][9];
        boolean[][] cols   = new boolean[9][9];
        boolean[][] boxes  = new boolean[9][9];

        for (int i = 0; i < 9; i++) {
            for (int j = 0; j < 9; j++) {
                char ch = board[i][j];
                if (ch == '.') {
                    continue;  // 空格跳过
                }
                int num = ch - '1';  // 映射到 0..8

                // 计算当前格属于哪个 3x3 宫格
                int boxIndex = (i / 3) * 3 + (j / 3);

                // 如果某行、某列或某宫格里已经存在该数字，直接返回 false
                if (rows[i][num] || cols[j][num] || boxes[boxIndex][num]) {
                    return false;
                }

                // 否则就标记为已出现
                rows[i][num]  = true;
                cols[j][num]  = true;
                boxes[boxIndex][num] = true;
            }
        }

        return true;  // 全部检查完毕，没有冲突
    }
}
