package range;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目： 57. 插入区间 (insert)
 * 描述：给你一个 无重叠的 ，按照区间起始端点排序的区间列表 intervals，其中 intervals[i] = [starti, endi] 表示第 i 个区间的开始和结束，并且 intervals 按照 starti 升序排列。同样给定一个区间 newInterval = [start, end] 表示另一个区间的开始和结束。
 * 在 intervals 中插入区间 newInterval，使得 intervals 依然按照 starti 升序排列，且区间之间不重叠（如果有必要的话，可以合并区间）。
 * 返回插入之后的 intervals。
 * 注意 你不需要原地修改 intervals。你可以创建一个新数组然后返回它。
 *
 * 示例 1：
 输入：intervals = [[1,3],[6,9]], newInterval = [2,5]
 输出：[[1,5],[6,9]]

 * 链接：https://leetcode.cn/problems/insert-interval/
 */
//想起来有点复杂。
public class Insert {
    public int[][] insert(int[][] intervals, int[] newInterval) {
        List<int[]> res = new ArrayList<>();
        int i = 0, n = intervals.length;

        // 第一阶段：添加所有在 newInterval 左侧且不重叠的区间
        while (i < n && intervals[i][1] < newInterval[0]) {
            res.add(intervals[i]);
            i++;
        }

        // 第二阶段：与 newInterval 重叠的区间，合并到 newInterval
        while (i < n && intervals[i][0] <= newInterval[1]) {
            newInterval[0] = Math.min(newInterval[0], intervals[i][0]);
            newInterval[1] = Math.max(newInterval[1], intervals[i][1]);
            i++;
        }
        // 把合并后的 newInterval 加进去
        res.add(newInterval);

        // 第三阶段：添加所有在 newInterval 右侧且不重叠的区间
        while (i < n) {
            res.add(intervals[i]);
            i++;
        }

        // 转回二维数组并返回
        return res.toArray(new int[res.size()][]);
    }
}
