package range;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目：228. 汇总区间 (summaryRanges)
 * 描述：给定一个  无重复元素 的 有序 整数数组 nums 。
 *
 * 返回 恰好覆盖数组中所有数字 的 最小有序 区间范围列表 。也就是说，nums 的每个元素都恰好被某个区间范围所覆盖，并且不存在属于某个范围但不属于 nums 的数字 x 。
 *
 * 列表中的每个区间范围 [a,b] 应该按如下格式输出：
 *
 * "a->b" ，如果 a != b
 * "a" ，如果 a == b
 *
 * 链接：https://leetcode.cn/problems/summary-ranges/
 *
 示例 1：
 输入：nums = [0,1,2,4,5,7]
 输出：["0->2","4->5","7"]
 解释：区间范围是：
 [0,2] --> "0->2"
 [4,5] --> "4->5"
 [7,7] --> "7"

 */
public class SummaryRanges {
    public List<String> summaryRanges(int[] nums) {
        List<String> ranges = new ArrayList<>();
        if (nums == null || nums.length == 0) {
            return ranges;
        }

        int start = nums[0], end = nums[0];
        StringBuilder sb = new StringBuilder();

        for (int i = 1; i < nums.length; i++) {
            if (nums[i] == end + 1) {
                end = nums[i];
            } else {
                sb.append(start);
                if (start != end) {
                    sb.append("->").append(end);
                }
                ranges.add(sb.toString());
                sb.setLength(0);
                start = end = nums[i];
            }
        }

        sb.append(start);
        if (start != end) {
            sb.append("->").append(end);
        }
        ranges.add(sb.toString());

        return ranges;
    }
}
