package sort;

public class QuickSort {

    // 交换数组中两个元素的位置
    public  void quickSort(int[] arr, int begin, int end) {
        if (begin >= end) {
            return;
        }
        //划分为满足上述条件的两个子表，返回基准位置
        int pos=partition(arr,begin,end);
        //对两个子表进行递归排序
        quickSort(arr, begin, pos - 1);
        quickSort(arr, pos + 1, end);
    }
    //划分左右子序列，返回基准位置
    public int partition(int[] arr, int i, int j){
        int temp = arr[i];
        while (i < j) {
            //在右边找到小于temp的放到左边
            while (i < j && arr[j] >= temp) {
                j--;
            }
            arr[i] = arr[j];
            //在左边找到大或等于于temp的放到右边
            while (i < j && arr[i] <= temp) {
                i++;
            }
            arr[j] = arr[i];
        }
        //将temp放在剩下的基准位置i、j均可
        arr[i] = temp;
        return i;
    }

    public static void main(String[] args) {
        int[] arr = {49, 38, 65, 97, 76, 13, 27, 49};
        QuickSort solution = new QuickSort();
        solution.quickSort(arr, 0, arr.length - 1);

        System.out.println("\n排序后:");
        for (int num : arr) {
            System.out.print(num + " ");
        }
    }
}
