package stack;

import java.util.ArrayDeque;
import java.util.Deque;

/**
 * 题目： 227. 基本计算器 II (calculate2)
 * 描述：给你一个字符串表达式 s ，请你实现一个基本计算器来计算并返回它的值。
 * 整数除法仅保留整数部分。
 * 你可以假设给定的表达式总是有效的。所有中间结果将在 [-231, 231 - 1] 的范围内。
 *
 * 示例 1：
 输入：s = " 3+5 / 2 "
 输出：5

 * 链接：https://leetcode.cn/problems/basic-calculator-ii/
 */
//不会 学下思路
public class Calculate2 {
    /**
     1. 操作符优先级
     首先要理解一个重要的点——乘法和除法的优先级高于加法和减法。因此，在计算过程中，需要按照操作符的优先级来处理：

     乘法（*）和除法（/）是 立即计算的，一旦遇到它们，就需要把栈中的前一个数与当前的数字一起计算。
     加法（+）和减法（-）是 延迟计算的，它们需要在下一步遇到新的操作符时计算 => 最后统一计算栈中的元素之和

     2. 栈的使用
     栈是用来存储每个数值的，我们将每个数值根据其操作符的类型（加法、减法、乘法或除法）计算后，放入栈中
     */
    //s = " 3+5 / 2 "
    public int calculate(String s) {
        Deque<Integer> stack = new ArrayDeque<Integer>();
        char preSign = '+';
        int num = 0;
        int n = s.length();
        for (int i = 0; i < n; ++i) {
            if (Character.isDigit(s.charAt(i))) {
                num = num * 10 + s.charAt(i) - '0';
            }
            if (!Character.isDigit(s.charAt(i)) && s.charAt(i) != ' ' || i == n - 1) {
                switch (preSign) {
                    case '+':
                        stack.push(num);
                        break;
                    case '-':
                        stack.push(-num);
                        break;
                    case '*':
                        stack.push(stack.pop() * num);
                        break;
                    default:
                        stack.push(stack.pop() / num);
                }
                preSign = s.charAt(i);
                num = 0;
            }
        }
        int ans = 0;
        while (!stack.isEmpty()) {
            ans += stack.pop();
        }
        return ans;
    }
    public static void main(String[] args) {
        Calculate2 calculator = new Calculate2();

        // 测试用例 1
        String expression1 = "3/2";
        System.out.println("输入: " + expression1);
        System.out.println("输出: " + calculator.calculate(expression1));  // 期望输出 5

        // 测试用例 2
        String expression2 = "3+2*2";
        System.out.println("输入: " + expression2);
        System.out.println("输出: " + calculator.calculate(expression2));  // 期望输出 7
    }
}
