package stack;

import java.util.ArrayDeque;
import java.util.Deque;

/**
 * 题目： 739. 每日温度 (dailyTemperatures)
 * 描述：给定一个整数数组 temperatures ，表示每天的温度，返回一个数组 answer ，其中 answer[i] 是指对于第 i 天，下一个更高温度出现在几天后。如果气温在这之后都不会升高，请在该位置用 0 来代替。

 * 示例 1：
 输入: temperatures = [73,74,75,71,69,72,76,73]
 输出: [1,1,4,2,1,1,0,0]

 * 链接：https://leetcode.cn/problems/daily-temperatures/
 */
//第一次做没想到怎么利用栈
public class DailyTemperatures {
    public int[] dailyTemperatures(int[] temperatures) {
        // 结果数组，初始化为全零
        int[] result = new int[temperatures.length];

        // 栈，存储温度的下标
        Deque<Integer> stack = new ArrayDeque<>();

        // 遍历整个温度数组
        for (int i = 0; i < temperatures.length; i++) {
            // 当前温度
            int currentTemperature = temperatures[i];

            // 处理栈中的元素，直到栈为空或者栈顶的温度大于当前温度
            while (!stack.isEmpty() && temperatures[stack.peek()] < currentTemperature) {
                // 获取栈顶的下标
                int prevIndex = stack.pop();

                // 计算当前温度和栈顶温度之间的天数差，并赋值给结果数组
                result[prevIndex] = i - prevIndex;
            }

            // 当前下标压入栈
            stack.push(i);
        }

        // 返回最终的结果数组
        return result;
    }
}
