package stack;

import java.util.ArrayDeque;
import java.util.Deque;
import java.util.LinkedList;

/**
 * 题目： 394. 字符串解码 (decodeString)
 * 描述：给定一个经过编码的字符串，返回它解码后的字符串。
 * 编码规则为: k[encoded_string]，表示其中方括号内部的 encoded_string 正好重复 k 次。注意 k 保证为正整数。
 * 你可以认为输入字符串总是有效的；输入字符串中没有额外的空格，且输入的方括号总是符合格式要求的。
 * 此外，你可以认为原始数据不包含数字，所有的数字只表示重复的次数 k ，例如不会出现像 3a 或 2[4] 的输入。

 * 示例 1：
 输入：s = "3[a]2[bc]"
 输出："aaabcbc"

 * 链接：https://leetcode.cn/problems/search-in-rotated-sorted-array/
 */
//不会 有难度！
public class DecodeString {
    //s = "3[a]2[bc]"   "3[a2[c]]"
    public String decodeString(String s) {
        // 定义两个栈
        Deque<Integer> countStack = new LinkedList<>();
        Deque<StringBuilder> stringStack = new LinkedList<>();

        StringBuilder current = new StringBuilder();
        int k = 0; // 用于保存数字

        for (int i = 0; i < s.length(); i++) {
            char ch = s.charAt(i);
            if (Character.isDigit(ch)) {
                // 可能有多位数字，所以需要乘10再加当前数字
                k = k * 10 + (ch - '0');
            } else if (ch == '[') {
                // 遇到左括号，先将当前数字和字符串入栈
                countStack.push(k);
                stringStack.push(current);
                // 重置 k 和 current
                k = 0;
                current = new StringBuilder();
            } else if (ch == ']') {
                //  当我们遇到 ']' 时，可以从栈中取出上一层的字符串，并将当前解码的部分附加到这个上一层的字符串后面。
                int count = countStack.pop();
                StringBuilder decoded = stringStack.pop();
                // 将当前字符串重复 count 次后追加到上层字符串中
                for (int j = 0; j < count; j++) {
                    decoded.append(current);
                }
                current = decoded;
            } else {
                // 普通字符直接追加
                current.append(ch);
            }
        }
        return current.toString();
    }
}