package stack;

import java.util.ArrayDeque;
import java.util.Deque;

/**
 * 题目： 150. 逆波兰表达式求值 (evalRPN)
 * 描述：给你一个字符串数组 tokens ，表示一个根据 逆波兰表示法 表示的算术表达式。
 * 请你计算该表达式。返回一个表示表达式值的整数。
 * 注意：
 * 有效的算符为 '+'、'-'、'*' 和 '/' 。
 * 每个操作数（运算对象）都可以是一个整数或者另一个表达式。
 * 两个整数之间的除法总是 向零截断 。
 * 表达式中不含除零运算。
 * 输入是一个根据逆波兰表示法表示的算术表达式。
 *
 * 示例 1：
 输入：tokens = ["2","1","+","3","*"]
 输出：9
 解释：该算式转化为常见的中缀算术表达式为：((2 + 1) * 3) = 9

 * 链接：https://leetcode.cn/problems/evaluate-reverse-polish-notation/
 */
public class EvalRPN {
    public int evalRPN(String[] tokens) {
        Deque<Integer> stack = new ArrayDeque<>();

        for (String token : tokens) {
            if (token.equals("+") || token.equals("-") || token.equals("*") || token.equals("/")) {
                // 如果是运算符，出栈两个操作数进行运算
                int b = stack.pop();
                int a = stack.pop();
                int result = 0;
                switch (token) {
                    case "+":
                        result = a + b;
                        break;
                    case "-":
                        result = a - b;
                        break;
                    case "*":
                        result = a * b;
                        break;
                    case "/":
                        result = a / b;  // 除法自动向零取整
                        break;
                }
                stack.push(result);
            } else {
                // 否则是数字，直接入栈
                stack.push(Integer.parseInt(token));
            }
        }

        // 最后栈中只剩下一个数字，就是计算结果
        return stack.pop();
    }
}
