package stack;

import java.util.ArrayDeque;
import java.util.Deque;
import java.util.HashMap;

/**
 * 题目： 20. 有效的括号 (isValid)
 * 描述：给定一个只包括 '('，')'，'{'，'}'，'['，']' 的字符串 s ，判断字符串是否有效。
 *
 * 有效字符串需满足：
 *
 * 左括号必须用相同类型的右括号闭合。
 * 左括号必须以正确的顺序闭合。
 * 每个右括号都有一个对应的相同类型的左括号。
 *
 * 链接：https://leetcode.cn/problems/valid-parentheses/
 */
public class IsValid {
    public boolean isValid(String s) {
        // 如果长度为奇数，直接返回 false
        int sz = s.length();
        if (sz % 2 == 1) return false;

        // 映射括号
        HashMap<Character, Character> map = new HashMap<>();
        map.put('(', ')');
        map.put('[', ']');
        map.put('{', '}');

        Deque<Character> stack = new ArrayDeque<>();

        for (int i = 0; i < sz; i++) {
            char cur = s.charAt(i);

            // 如果是左括号，压入栈
            if (map.containsKey(cur)) {
                stack.push(cur);
            }
            // 如果是右括号，检查栈顶是否是匹配的左括号
            else {
                if (stack.isEmpty() || map.get(stack.pop()) != cur) {
                    return false;
                }
            }
        }

        // 最后栈应为空
        return stack.isEmpty();
    }
}
