package stack;

import java.util.Stack;

/**
 * 题目： 155. 最小栈 (MinStack)
 * 描述：设计一个支持 push ，pop ，top 操作，并能在常数时间内检索到最小元素的栈。
 *
 * 实现 MinStack 类:
 * MinStack() 初始化堆栈对象。
 * void push(int val) 将元素val推入堆栈。
 * void pop() 删除堆栈顶部的元素。
 * int top() 获取堆栈顶部的元素。
 * int getMin() 获取堆栈中的最小元素。
 *
 * 链接：https://leetcode.cn/problems/min-stack/description/
 */
public class MinStack {

    private Stack<Integer> stack;      // 主栈
    private Stack<Integer> minStack;   // 辅助栈，存储每个阶段的最小值

    public MinStack() {
        stack = new Stack<>();
        minStack = new Stack<>();
    }

    // 向栈中压入一个值
    public void push(int val) {
        stack.push(val);
        // 如果辅助栈为空，或者当前值比辅助栈的栈顶元素还小，压入辅助栈
        if (minStack.isEmpty() || val <= minStack.peek()) {
            minStack.push(val);
        }
    }

    // 弹出栈顶元素
    public void pop() {
        // 弹出主栈的栈顶元素
        int poppedValue = stack.pop();
        // 如果弹出的元素是当前最小值，则同时弹出辅助栈的栈顶元素
        if (poppedValue == minStack.peek()) {
            minStack.pop();
        }
    }

    // 获取栈顶元素
    public int top() {
        return stack.peek();
    }

    // 获取当前栈中的最小值
    public int getMin() {
        return minStack.peek();
    }
}
