package stack;

import java.util.ArrayDeque;
import java.util.Deque;
import java.util.HashMap;

/**
 * 题目： 496. 下一个更大元素 I (nextGreaterElement)
 * 描述：nums1 中数字 x 的 下一个更大元素 是指 x 在 nums2 中对应位置 右侧 的 第一个 比 x 大的元素。
 *
 * 给你两个 没有重复元素 的数组 nums1 和 nums2 ，下标从 0 开始计数，其中nums1 是 nums2 的子集。
 *
 * 对于每个 0 <= i < nums1.length ，找出满足 nums1[i] == nums2[j] 的下标 j ，并且在 nums2 确定 nums2[j] 的 下一个更大元素 。如果不存在下一个更大元素，那么本次查询的答案是 -1 。
 *
 * 返回一个长度为 nums1.length 的数组 ans 作为答案，满足 ans[i] 是如上所述的 下一个更大元素 。
 *
 * 示例 1：
 输入：nums1 = [4,1,2], nums2 = [1,3,4,2].
 输出：[-1,3,-1]
 解释：nums1 中每个值的下一个更大元素如下所述：
 - 4 ，用加粗斜体标识，nums2 = [1,3,4,2]。不存在下一个更大元素，所以答案是 -1 。
 - 1 ，用加粗斜体标识，nums2 = [1,3,4,2]。下一个更大元素是 3 。
 - 2 ，用加粗斜体标识，nums2 = [1,3,4,2]。不存在下一个更大元素，所以答案是 -1 。

 * 链接：https://leetcode.cn/problems/next-greater-element-i/
 */
public class NextGreaterElement {
    public int[] nextGreaterElement(int[] nums1, int[] nums2) {
        Deque<Integer>stack=new ArrayDeque<>();
        HashMap<Integer,Integer>map=new HashMap<>();
        int[] res=new int[nums1.length];
        for (int cur : nums2) {
            while (!stack.isEmpty()) {
                int curtop = stack.peek();
                if (cur > curtop) {
                    stack.pop();
                    map.put(curtop, cur);
                }else break;
            }
            stack.push(cur);
        }
        while (!stack.isEmpty()) {
            map.put(stack.pop(),-1);
        }
        for (int i = 0; i < nums1.length; i++) {
            res[i]=map.get(nums1[i]);
        }
        return res;
    }
}
