package stack;

import java.util.ArrayDeque;
import java.util.Deque;

/**
 * 题目： 503. 下一个更大元素 II (nextGreaterElements)
 * 描述：给定一个循环数组 nums （ nums[nums.length - 1] 的下一个元素是 nums[0] ），返回 nums 中每个元素的 下一个更大元素 。
 * 数字 x 的 下一个更大的元素 是按数组遍历顺序，这个数字之后的第一个比它更大的数，这意味着你应该循环地搜索它的下一个更大的数。如果不存在，则输出 -1 。
 * <p>
 * 示例 1：
 * 输入: nums = [1,2,1]
 * 输出: [2,-1,2]
 * 解释: 第一个 1 的下一个更大的数是 2；
 * 数字 2 找不到下一个更大的数；
 * 第二个 1 的下一个最大的数需要循环搜索，结果也是 2。
 * <p>
 * 链接：https://leetcode.cn/problems/next-greater-element-ii/description/
 */
//不会，学习！
public class NextGreaterElements {
    public int[] nextGreaterElements(int[] nums) {
        int n = nums.length;
        int[] result = new int[n];
        Deque<Integer> stack = new ArrayDeque<>();

        // 初始化结果数组为 -1，表示如果没有更大元素则为 -1
        for (int i = 0; i < n; i++) {
            result[i] = -1;
        }

        // 遍历数组两倍的长度，以模拟循环
        for (int i = 0; i < 2 * n; i++) {
            int currentIndex = i % n; // 当前元素的下标，模拟循环
            // 当栈不为空且当前元素大于栈顶对应的元素时，更新结果
            while (!stack.isEmpty() && nums[currentIndex] > nums[stack.peek()]) {
                int prevIndex = stack.pop();
                result[prevIndex] = nums[currentIndex];
            }
            // 只在前 n 个元素时将索引加入栈中
            if (i < n) {
                stack.push(currentIndex);
            }
        }

        return result;
    }
}
