package tree;
/**
 * 题目： 543. 二叉树的直径  (diameterOfBinaryTree)
 * 描述：给你一棵二叉树的根节点，返回该树的 直径 。
 * 二叉树的 直径 是指树中任意两个节点之间最长路径的 长度 。这条路径可能经过也可能不经过根节点 root 。
 * 两节点之间路径的 长度 由它们之间边数表示。

 * 链接：https://leetcode.cn/problems/diameter-of-binary-tree/

 */
public class DiameterOfBinaryTree {

    private int maxDiameter = 0;
    public int diameterOfBinaryTree(TreeNode root) {
        depth(root);
        return maxDiameter;
    }

    // 递归函数，返回以 node 为根的树的深度
    private int depth(TreeNode node) {
        if (node == null) {
            return 0;
        }
        int leftDepth = depth(node.left);
        int rightDepth = depth(node.right);

        // 直径为左子树深度+右子树深度
        maxDiameter = Math.max(maxDiameter, leftDepth + rightDepth);

        // 返回当前树的深度
        return Math.max(leftDepth, rightDepth) + 1;
    }
}
