package trick;

import java.util.Arrays;

/**
 * 题目： 31. 下一个排列 (nextPermutation)
 * 描述：整数数组的一个 排列  就是将其所有成员以序列或线性顺序排列。
 *
 * 例如，arr = [1,2,3] ，以下这些都可以视作 arr 的排列：[1,2,3]、[1,3,2]、[3,1,2]、[2,3,1] 。
 * 整数数组的 下一个排列 是指其整数的下一个字典序更大的排列。更正式地，如果数组的所有排列根据其字典顺序从小到大排列在一个容器中，那么数组的 下一个排列 就是在这个有序容器中排在它后面的那个排列。如果不存在下一个更大的排列，那么这个数组必须重排为字典序最小的排列（即，其元素按升序排列）。
 *
 * 例如，arr = [1,2,3] 的下一个排列是 [1,3,2] 。
 * 类似地，arr = [2,3,1] 的下一个排列是 [3,1,2] 。
 * 而 arr = [3,2,1] 的下一个排列是 [1,2,3] ，因为 [3,2,1] 不存在一个字典序更大的排列。
 * 给你一个整数数组 nums ，找出 nums 的下一个排列。
 *
 * 必须 原地 修改，只允许使用额外常数空间。
 *
 示例 1：
 输入：nums = [1,2,3]
 输出：[1,3,2]

 * 链接：https://leetcode.cn/problems/next-permutation/
 */
public class NextPermutation {
    public void nextPermutation(int[] nums) {
        int n = nums.length;
        // 1. 从右向左，找到第一个「前驱/枢轴」i，使得 nums[i] < nums[j]（j>i）
        //    这样 nums[i+1..n-1] 一定是非增的
        for (int i = n - 2; i >= 0; i--) {
            // 2. 对于找到的 i，再从右向左找第一个 nums[j] > nums[i]
            for (int j = n - 1; j > i; j--) {
                if (nums[j] > nums[i]) {
                    // 3. 交换枢轴 i 和后缀中刚好比它大的那个 j
                    int tmp = nums[i];
                    nums[i] = nums[j];
                    nums[j] = tmp;
                    // 4. 将 i+1 到末尾这段降序数组，升序排列，得到下一个最小排列
                    Arrays.sort(nums, i + 1, n);
                    return;
                }
            }
        }
        // 如果整个数组都是降序的，说明已经是最大排列了，直接变成最小排列（全升序）
        Arrays.sort(nums);
    }
}
