package trick;
/**
 * 题目： 75. 颜色分类 (singleNumber)
 * 描述：给定一个包含红色、白色和蓝色、共 n 个元素的数组 nums ，原地 对它们进行排序，使得相同颜色的元素相邻，并按照红色、白色、蓝色顺序排列。
 * 我们使用整数 0、 1 和 2 分别表示红色、白色和蓝色。
 * 必须在不使用库内置的 sort 函数的情况下解决这个问题。
 *
 示例 1：
 输入：nums = [2,0,2,1,1,0]
 输出：[0,0,1,1,2,2]

 * 链接：https://leetcode.cn/problems/sort-colors/
 */
public class SortColors {
    void swap(int[]a,int i,int j){
        int temp=a[i];
        a[i]=a[j];
        a[j]=temp;
    }

    /**
     * [0……left-1]    全是 0
     * [left……i-1]    全是 1
     * [i……right]     未知区
     * [right+1……n-1] 全是 2
     * @param nums
     */
    public void sortColors(int[] nums) {
        int left = 0, i = 0, right = nums.length - 1;
        while (i <= right) {
            if (nums[i] == 0) {
                swap(nums, left++, i++);
            } else if (nums[i] == 2) {
                swap(nums, i, right--);
            } else {  // nums[i] == 1
                i++;
            }
        }
    }
}
