package twopointers;
/**
 * 题目：11.盛最多水的容器 (maxArea)
 * 描述：给定一个长度为 n 的整数数组 height 。有 n 条垂线，第 i 条线的两个端点是 (i, 0) 和 (i, height[i]) 。
 *      找出其中的两条线，使得它们与 x 轴共同构成的容器可以容纳最多的水。
 *      返回容器可以储存的最大水量。
 *      说明：你不能倾斜容器。
 * 链接：https://leetcode.cn/problems/container-with-most-water/
 *
 示例 1:
 输入：[1,8,6,2,5,4,8,3,7]
 输出：49
 解释：图中垂直线代表输入数组 [1,8,6,2,5,4,8,3,7]。在此情况下，容器能够容纳水（表示为蓝色部分）的最大值为 49。

 示例 2:
 输入：height = [1,1]
 输出：1
 */
public class MaxArea {

    //暴力解法O(N^2) 没过所有例子
    public int maxArea1(int[] height) {
        int maxarea=-1;
        int temparea=-1;
        for (int i = 0; i < height.length; i++) {
            for (int j = i+1; j < height.length; j++) {
                temparea=(j-i)*Math.min(height[i],height[j]);
                if(temparea>maxarea){
                    maxarea=temparea;
                }
            }
        }
        return maxarea;
    }
    //双指针
    /**
     * 在每个状态下，无论长板或短板向中间收窄一格，都会导致水槽 底边宽度 −1 变短：
     *
     * 若向内 移动短板 ，水槽的短板 min(h[i],h[j]) 可能变大，因此下个水槽的面积 可能增大 。
     * 若向内 移动长板 ，水槽的短板 min(h[i],h[j]) 不变或变小，因此下个水槽的面积 一定变小 。
     * 因此，初始化双指针分列水槽左右两端，循环每轮将短板向内移动一格，并更新面积最大值，直到两指针相遇时跳出；即可获得最大面积。
     */
    public int maxArea(int[] height) {
        int i=0,j=height.length-1;
        int maxarea=Integer.MIN_VALUE,temparea=Integer.MIN_VALUE;
        while(i<j){
            temparea=(j-i)*Math.min(height[i],height[j]);
            if(temparea>maxarea){
                maxarea=temparea;
            }
            if (height[i]<height[j])
                i+=1;
            else
                j-=1;
        }
        return maxarea;
    }
}
